{$N+,E-,O+,S+,R-,D+}
{

  3DS to XVO (eXtended Vector Object) convertorr
  written by BoRZoM
  version 0.12

  XVO format:
    'XVO'
    OBJECT  NUMBER     Integer

    --Objects--

    FLAGS   DATA       WORD
    VERTEX  NUMBER     WORD
    FACE    NUMBER     WORD

    --ObjectData--

    VERTEX  DATA       VertNum
     Vertex  (x,y,z)   Integer
     Normal  (x,y,z)   Integer
    FACE    DATA       FaceNum
     Polygon (a,b,c)   Integer
     Normal  (x,y,z)   Integer
    TEXTURE DATA       (x,y)*VertNum    * flags bit 0
    COLOR   DATA         (a)*FaceNum    * flags bit 1

}

Uses CRT;

type
  Point3D = record x, y, z : Integer end;
  Point2D = record x, y    : Integer end;
  VertexFloat3D = record x,y,z : Single end;
  Vertex3D= record
    Point  : Point3D;
    Normal : Point3D;
  End;
  Face3D   = record
    Poly   : Point3D;
    Normal : Point3D;
  End;
  TPoint3D = array [1..16383] of ^Point3D;
  TPoint2D = array [1..16383] of ^Point2D;
  TFace3D  = array [1..16383] of ^Face3D;
  TVertex3D= array [1..16383] of ^Vertex3D;
  TVertexFloat3D = array [1..16383] of ^VertexFloat3D;
  TByte    = array [1..16383] of Byte;
  IDRec    = array [1..3] of Char;
  Header   = record
    ID      : IDRec;
    Objects : Word;
  End;
  XVO      = record
    Flags     : Word;
    VertNum   : Word;
    FaceNum   : Word;
    Vertex    : ^TVertex3D;
    VertexF   : ^TVertexFloat3D;
    Face      : ^TFace3D;
    Texture   : ^TPoint2D;
    Colors    : ^TByte;
  End;

const
  XVOID   : IDRec = 'XVO';
  f3DS    = 0;
  fVO     = 1;
  fASC    = 2;
  fDXF    = 3;
  fXVO    = -2;
  fError  = -1;

var
  pal                        : Array [0..767] of Byte;
  Objects                    : Array [0..255] of XVO;
  f                          : File;
  fName, Name, s             : String;
  t                          : Text;
  Page, Save, Map            : Pointer;
  sx, sy, sz                 : Single;
  rx, ry, rz, Scale          : Real;
  Mapping, Merge,
  Preview, Error, Skip, Swap : Boolean;
  b                          : Byte;
  Chunkid                    : Word;
  x, y, z, angle, a, Number  : Integer;
  Filesize, NextChunk        : Longint;


{----------------------------------------------------------------------------}

Function Upper (s : String) : String;
var
  x : Byte;

Begin
  If length (s) > 0 then
    For x := 1 to Length (s) do s [x] := Upcase (s [x]);
  Upper := s;
End;

Procedure BlockReadWord (var f : File; var s : String);
var
  ch : Char;

Begin
  s := '';
  Repeat
    BlockRead (f, ch, 1);
    s := s + ch;
  Until ch=#0;
End;

Function ObjectType (s : String) : Integer;
Begin
  If Pos ('.3DS', s) > 0 then ObjectType := f3DS else
    If Pos ('.VO', s) > 0 then ObjectType := fVO else
      If Pos ('.ASC', s) > 0 then ObjectType := fASC else
        If Pos ('.DXF', s) > 0 then ObjectType := fDXF else
          If Pos ('.XVO', s) > 0 then ObjectType := fXVO else
            ObjectType := fError;
End;

Procedure GetMem (var pt; Size : Word);
var
  p : Pointer absolute pt;

Begin
  If MaxAvail < Size then begin
    Writeln ('  error: Not enough memory!');
    Halt;
  End;
  SYSTEM.Getmem (p, Size);
End;

Procedure nGetMem (var pt; Size : Word);
var
  p : Pointer absolute pt;

Begin
  p := NIL;
  While p = NIL do Begin
    Getmem (p, size);
    if ofs (p^) <> 0 then begin
      Freemem (p, Size);
      Getmem (p, 1);
      p := NIL;
    End;
  End;
End;

{----------------------------------------------------------------------------}

Procedure CalculateNormals (Obj : Byte);
var
  Count,
  Count2,
  Count3,
  ox, oy,
  a,  b,  c,
  a1, b1, c1 : Longint;
  i, j, k, d : Real;
  FaceCount  : Array [1..3] of Word;
  x, y, z    : Array [1..3] of Real;
  tv         : Array [1..3] of Point3D;
  Used       : Array [1..128] of Integer;
  Flag       : Boolean;
  tx, ty, tz : Longint;
  px, py, pz : Longint;
  Num        : Integer;

Begin
  ox := WhereX;
  oy := WhereY;
  { Polygons }
  For Count := 1 to Objects [Obj].FaceNum do Begin
    Gotoxy (ox, oy);
    Write ('  Calculating normals for object ', Obj+1,' (', Objects[Obj].FaceNum, ' faces): ',
                                                Round (Count*50/Objects [Obj].FaceNum),'%');
    a := Objects [Obj].Face^ [Count]^.Poly.x+1;
    b := Objects [Obj].Face^ [Count]^.Poly.y+1;
    c := Objects [Obj].Face^ [Count]^.Poly.z+1;
    x [1] := Objects [Obj].VertexF^ [a]^.x;
    y [1] := Objects [Obj].VertexF^ [a]^.y;
    z [1] := Objects [Obj].VertexF^ [a]^.z;
    x [2] := Objects [Obj].VertexF^ [b]^.x;
    y [2] := Objects [Obj].VertexF^ [b]^.y;
    z [2] := Objects [Obj].VertexF^ [b]^.z;
    x [3] := Objects [Obj].VertexF^ [c]^.x;
    y [3] := Objects [Obj].VertexF^ [c]^.y;
    z [3] := Objects [Obj].VertexF^ [c]^.z;

    i := ((y[2] - y[1]) * (z[3] - z[1])) - ((z[2] - z[1]) * (y[3] - y[1]));
    j := ((z[2] - z[1]) * (x[3] - x[1])) - ((x[2] - x[1]) * (z[3] - z[1]));
    k := ((x[2] - x[1]) * (y[3] - y[1])) - ((y[2] - y[1]) * (x[3] - x[1]));
    d := Sqrt (Sqr (i)+Sqr (j)+Sqr (k));
    if d = 0 then d := 0.00000001;
    i := i / d;
    j := j / d;
    k := k / d;

    If Swap then Begin
      Objects [Obj].Face^ [Count]^.Normal.x := Round (i*512);
      Objects [Obj].Face^ [Count]^.Normal.y := Round (j*512);
      Objects [Obj].Face^ [Count]^.Normal.z := Round (k*512);
    End else Begin
      Objects [Obj].Face^ [Count]^.Normal.x := -Round (i*512);
      Objects [Obj].Face^ [Count]^.Normal.y := -Round (j*512);
      Objects [Obj].Face^ [Count]^.Normal.z := -Round (k*512);
    End;
  End;

  { Vertices }

  For Count := 1 to Objects [Obj].FaceNum do Begin
    Gotoxy (ox, oy);
    Write ('  Calculating normals for object ', Obj+1,' (', Objects[Obj].FaceNum, ' faces): ',
                                             50+Round (Count*50/Objects [Obj].FaceNum),'%');
    FaceCount [1] := 0;
    FaceCount [2] := 0;
    FaceCount [3] := 0;
    a := Objects [Obj].Face^ [Count]^.Poly.x;
    b := Objects [Obj].Face^ [Count]^.Poly.y;
    c := Objects [Obj].Face^ [Count]^.Poly.z;
    For Count2 := 1 to 3 do Begin
      tv [Count2].x := 0;
      tv [Count2].y := 0;
      tv [Count2].z := 0;
    End;
    For Count2 := 1 to Objects [Obj].FaceNum do Begin
      a1 := Objects [Obj].Face^ [Count2]^.Poly.x;
      b1 := Objects [Obj].Face^ [Count2]^.Poly.y;
      c1 := Objects [Obj].Face^ [Count2]^.Poly.z;
      If (a=a1) or (a=b1) or (a=c1) then Begin
        tv [1].x := tv [1].x + Objects [Obj].Face^ [Count2]^.Normal.x;
        tv [1].y := tv [1].y + Objects [Obj].Face^ [Count2]^.Normal.y;
        tv [1].z := tv [1].z + Objects [Obj].Face^ [Count2]^.Normal.z;
        Inc (FaceCount [1]);
      End;
      If (b=a1) or (b=b1) or (b=c1) then Begin
        tv [2].x := tv [2].x + Objects [Obj].Face^ [Count2]^.Normal.x;
        tv [2].y := tv [2].y + Objects [Obj].Face^ [Count2]^.Normal.y;
        tv [2].z := tv [2].z + Objects [Obj].Face^ [Count2]^.Normal.z;
        Inc (FaceCount [2]);
      End;
      If (c=a1) or (c=b1) or (c=c1) then Begin
        tv [3].x := tv [3].x + Objects [Obj].Face^ [Count2]^.Normal.x;
        tv [3].y := tv [3].y + Objects [Obj].Face^ [Count2]^.Normal.y;
        tv [3].z := tv [3].z + Objects [Obj].Face^ [Count2]^.Normal.z;
        Inc (FaceCount [3]);
      End;
    End;
    a := Objects [Obj].Face^ [Count]^.Poly.x+1;
    b := Objects [Obj].Face^ [Count]^.Poly.y+1;
    c := Objects [Obj].Face^ [Count]^.Poly.z+1;
    Objects [Obj].Vertex^ [a]^.Normal.x := tv [1].x div FaceCount [1];
    Objects [Obj].Vertex^ [a]^.Normal.y := tv [1].y div FaceCount [1];
    Objects [Obj].Vertex^ [a]^.Normal.z := tv [1].z div FaceCount [1];
    Objects [Obj].Vertex^ [b]^.Normal.x := tv [2].x div FaceCount [2];
    Objects [Obj].Vertex^ [b]^.Normal.y := tv [2].y div FaceCount [2];
    Objects [Obj].Vertex^ [b]^.Normal.z := tv [2].z div FaceCount [2];
    Objects [Obj].Vertex^ [c]^.Normal.x := tv [3].x div FaceCount [3];
    Objects [Obj].Vertex^ [c]^.Normal.y := tv [3].y div FaceCount [3];
    Objects [Obj].Vertex^ [c]^.Normal.z := tv [3].z div FaceCount [3];
  End;
  Writeln;
End;

Procedure SaveXVO (s : String; b : Boolean);
var
  f    : File;
  x, y : Integer;

Begin
  If b then Writeln ('  Saving file: ', s);
  Assign (f, s);
  Rewrite (f, 1);
  Blockwrite (f, XVOID, 3);
  Blockwrite (f, Number, 2);
  For x := 0 to Number-1 do Begin
    Blockwrite (f, Objects [x], 6);
    For y := 1 to Objects [x].VertNum do BlockWrite (f, Objects [x].Vertex^ [y]^, Sizeof (Vertex3D));
    For y := 1 to Objects [x].FaceNum do BlockWrite (f, Objects [x].Face^ [y]^, Sizeof (Face3D));
    If Objects [x].Flags and 1 = 1 then
      For y := 1 to Objects [x].VertNum do BlockWrite (f, Objects [x].Texture^ [y]^, Sizeof (Point2D));
    If Objects [x].Flags and 2 = 2 then BlockWrite (f, Objects [x].Colors^, Objects [x].FaceNum);
  End;
  Close (f);
End;

Procedure MergeObjects (b : Boolean);
var
  Total, Pol, Vert : Word;

Begin
  If b then Writeln ('  Merging objects...');
  If Number < 2 then Exit;
  Total := 0;
  Pol := 0;
  Vert := 0;
  Objects [Number].Flags := 0;       { all flags go to hell when merged }
  Objects [Number].FaceNum := 0;
  Objects [Number].VertNum := 0;
  New (Objects [Number].Vertex);
  New (Objects [Number].Face);
  New (Objects [Number].Texture);
  For a := 0 to Number-1 do Begin
    For x := 1 to Objects [a].VertNum do Begin
      Inc (Vert);
      Objects [Number].Vertex^ [Vert] := Objects [a].Vertex^ [x];
      Objects [Number].Texture^ [Vert] := Objects [a].Texture^ [x];
    End;
    For x := 1 to Objects [a].FaceNum do Begin
      Inc (Pol);
      Objects [Number].Face^ [Pol] := Objects [a].Face^ [x];
      Inc (Objects [Number].Face^ [Pol]^.Poly.x, Total);
      Inc (Objects [Number].Face^ [Pol]^.Poly.y, Total);
      Inc (Objects [Number].Face^ [Pol]^.Poly.z, Total);
    End;
    Inc (Total, Objects [a].VertNum);
  End;
  Objects [Number].VertNum := Vert;
  Objects [Number].FaceNum := Pol;
  Objects [Number].Flags := Objects [0].Flags;
  Objects [0] := Objects [Number];
  Number := 1;
  If b then
    Writeln ('  Merge statistics: ', Vert, ' vertexes, ', Pol, ' polygons.');
End;

{----------------------------------------------------------------------------}

Procedure ReadObject3DS;
Begin
  BlockRead (f, Chunkid, 2);
  BlockRead (f, Filesize, 4);
  If Chunkid <> $4D4D then Begin
    Writeln ('  error: Not a 3DS file!');
    Close (f);
    Halt;
  End;
  While not Eof (f) do Begin
    BlockRead (f, Chunkid, 2);
    BlockRead (f, Nextchunk, 4);
    Skip := True;
    Case Chunkid of
      $3D3D: Begin
        BlockRead (f, Chunkid, 2);
        BlockRead (f, Nextchunk, 4);
      End;
      $4000: Begin
        BlockReadWord (f, Name);
        Writeln ('  Reading object: ', Name);
        Inc (Number);
        Objects [Number-1].Flags := 0;
        Skip := False;
      End;
      $4600,
      $4700: Dec (Number);
      $4100: Skip := False;
      $4110: Begin
        Blockread (f, Objects [Number-1].VertNum, 2);
        Getmem (Objects [Number-1].Vertex, 4*Objects [Number-1].VertNum);
        Getmem (Objects [Number-1].VertexF, 4*Objects [Number-1].VertNum);
        For a := 1 to Objects [Number-1].VertNum do Begin
          New (Objects [Number-1].Vertex^ [a]);
          New (Objects [Number-1].VertexF^ [a]);
          Blockread (f, sx, 4); rx := sx;
          Blockread (f, sy, 4); ry := sy;
          Blockread (f, sz, 4); rz := sz;
          Objects [Number-1].VertexF^ [a]^.x := sx;
          Objects [Number-1].VertexF^ [a]^.y := sy;
          Objects [Number-1].VertexF^ [a]^.z := sz;
          Objects [Number-1].Vertex^ [a]^.Point.x := Round (rx/Scale*256);
          Objects [Number-1].Vertex^ [a]^.Point.y := Round (ry/Scale*256);
          Objects [Number-1].Vertex^ [a]^.Point.z := Round (rz/Scale*256);
        End;
        Skip := False;
      End;
      $4120: Begin
        Blockread (f, Objects [Number-1].FaceNum, 2);
        Getmem (Objects [Number-1].Face, 4*Objects [Number-1].FaceNum);
        For a := 1 to Objects [Number-1].FaceNum do Begin
          New (Objects [Number-1].Face^ [a]);
          Blockread (f, Objects [Number-1].Face^ [a]^.Poly.z, 2);
          Blockread (f, Objects [Number-1].Face^ [a]^.Poly.y, 2);
          Blockread (f, Objects [Number-1].Face^ [a]^.Poly.x, 2);
          Seek (f, Filepos (f)+2);
        End;
        Skip := False;
      End;
      $4140: If Mapping then Begin
        Writeln ('  Reading mapping data...');
        Objects [Number-1].Flags := Objects [Number-1].Flags or 1;
        Getmem (Objects [Number-1].Texture, 4*Objects [Number-1].VertNum);
        Blockread (f, x, 2);
        For a := 1 to x do Begin
          New (Objects [Number-1].Texture^ [a]);
          Blockread (f, sy, 4);
          Blockread (f, sx, 4);
          Objects [Number-1].Texture^ [a]^.x := 255-Round (sx*256);
          Objects [Number-1].Texture^ [a]^.y := Round (sy*256);
          Skip := False;
        End;
      End;
    End;
    If Skip then Seek (f, Filepos (f)+NextChunk-6);
  End;
End;

Procedure ReadObjectASC;
var
  s : String;
  f,
  v : Word;

  Function Name (s : String) : String;
  Begin
    s [Pos ('"', s)] := ^A;
    s [Pos ('"', s)] := ^B;
    Name := Copy (s, Pos (^A, s)+1, Pos (^B, s)-Pos (^A, s)-1);
  End;

  Function GetReal (s1, s2 : String) : Real;
  var
    x, y : Integer;
    r    : Real;

  Begin
    If Pos (s1, s2) = 0 then Begin
      GetReal := 0;
      Exit;
    End;
    Delete (s2, 1, Pos (s1, s2)+Length(s1)-1);
    While s2 [1] = ' ' do delete (s2, 1, 1);
    If Pos (' ', s2) > 0 then
      Delete (s2, Pos (' ', s2), Length (s2)-Pos (' ', s2)+1);
    Val (s2, r, x);
    GetReal := r;
  End;

  Function GetWord (s1, s2 : String) : Integer;
  var
    x, y : Integer;

  Begin
    If Pos (s1, s2) = 0 then Begin
      GetWord := 0;
      Exit;
    End;
    Delete (s2, 1, Pos (s1, s2)+Length(s1)-1);
    While s2 [1] = ' ' do delete (s2, 1, 1);
    If Pos (' ', s2) > 0 then
      Delete (s2, Pos (' ', s2), Length (s2)-Pos (' ', s2)+1);
    Val (s2, x, y);
    GetWord := x;
  End;

Begin
  Assign (t, Paramstr (1));
  Reset (t);
  v := 0; f := 0;
  While not eof (t) do begin
    Readln (t, s);
    If Pos ('Named object', s) > 0 then
      Writeln ('  Reading object: ', name (s)) else
    If Pos ('Tri-mesh', s) > 0 then begin
      Inc (Number);
      Objects [Number-1].VertNum := GetWord ('Vertices:', s);
      Objects [Number-1].FaceNum := GetWord ('Faces:', s);
      Getmem (Objects [Number-1].Vertex, 4*Objects [Number-1].VertNum);
      Getmem (Objects [Number-1].VertexF, 4*Objects [Number-1].VertNum);
      Getmem (Objects [Number-1].Face, 4*Objects [Number-1].FaceNum);
      If (v = 1) or (f = 1) then Begin
        Writeln ('  error: Corrupted file!');
        Halt;
      End;
    End else
    If Pos ('Vertex list', s) > 0 then begin
      v := 1;
    End else
      If Pos ('Vertex', s) > 0 then begin
        New (Objects [Number-1].Vertex^ [v]);
        New (Objects [Number-1].VertexF^ [a]);
        Objects [Number-1].Vertex^ [v]^.Point.x := Round (GetReal ('X:', s)/Scale*256);
        Objects [Number-1].Vertex^ [v]^.Point.y := Round (GetReal ('Y:', s)/Scale*256);
        Objects [Number-1].Vertex^ [v]^.Point.z := Round (GetReal ('Z:', s)/Scale*256);
        Objects [Number-1].VertexF^ [a]^.x := GetReal ('X:', s);
        Objects [Number-1].VertexF^ [a]^.y := GetReal ('Y:', s);
        Objects [Number-1].VertexF^ [a]^.z := GetReal ('Z:', s);
        Inc (v);
      End else
    If Pos ('Face list', s) > 0 then begin
      f := 1;
    End else
      If Pos ('Face', s) > 0 then begin
        New (Objects [Number-1].Face^ [f]);
        Objects [Number-1].Face^ [f]^.Poly.x := GetWord ('A:', s);
        Objects [Number-1].Face^ [f]^.Poly.y := GetWord ('B:', s);
        Objects [Number-1].Face^ [f]^.Poly.z := GetWord ('C:', s);
        Inc (f);
      End;
  End;
  Close (t);
End;

Procedure ReadObjectDXF;
Begin
  Assign (t, Paramstr (1));
  Reset (t);


  Close (t);
End;

Procedure ReadObjectVO;
Begin
  Blockread (f, Chunkid, 2);
  If (ChunkId and 1 = 0) then begin
    Writeln ('  error: No vertex information!');
    Close (f);
    Halt;
  End;
  If (ChunkId and 2 = 0) then begin
    Writeln ('  error: No polygon information!');
    Close (f);
    Halt;
  End;
  Number := 1;
  Objects [Number-1].Flags := 0;
  Writeln ('  Reading object...');
  Blockread (f, Objects [Number-1].VertNum, 2);
  Getmem (Objects [Number-1].Vertex, 4*Objects [Number-1].VertNum);
  Getmem (Objects [Number-1].VertexF, 4*Objects [Number-1].VertNum);
  For a := 1 to Objects [Number-1].VertNum do Begin
    New (Objects [Number-1].Vertex^ [a]);
    New (Objects [Number-1].VertexF^ [a]);
    Blockread (f, x, 2);
    Blockread (f, y, 2);
    Blockread (f, z, 2);
    Objects [Number-1].Vertex^ [a]^.Point.x := Round (x/Scale*256);
    Objects [Number-1].Vertex^ [a]^.Point.y := Round (y/Scale*256);
    Objects [Number-1].Vertex^ [a]^.Point.z := Round (z/Scale*256);
    Objects [Number-1].VertexF^ [a]^.x := x;
    Objects [Number-1].VertexF^ [a]^.y := y;
    Objects [Number-1].VertexF^ [a]^.z := z;
  End;
  Blockread (f, Objects [Number-1].FaceNum, 2);
  Seek (f, Filepos (f)+1);
  Getmem (Objects [Number-1].Face, 4*Objects [Number-1].FaceNum);
  For a := 1 to Objects [Number-1].FaceNum do Begin
    New (Objects [Number-1].Face^ [a]);
    Blockread (f, Objects [Number-1].Face^ [a]^.Poly.x, 2);
    Blockread (f, Objects [Number-1].Face^ [a]^.Poly.y, 2);
    Blockread (f, Objects [Number-1].Face^ [a]^.Poly.z, 2);
  End;
  If ChunkId and 4  <> 0 then Seek (f, FilePos (f)+6*Objects [Number-1].FaceNum);
  If ChunkId and 8  <> 0 then Seek (f, FilePos (f)+6*Objects [Number-1].VertNum);
  If ChunkId and 16 <> 0 then Seek (f, FilePos (f)+  Objects [Number-1].FaceNum);
  If ChunkId and 32 <> 0 then Begin
    Writeln ('  Reading color data...');
    Getmem (Objects [Number-1].Colors, Objects [Number-1].FaceNum);
    Blockread (f, Objects [Number-1].Colors^, Objects [Number-1].FaceNum);
    Objects [Number-1].Flags := Objects [Number-1].Flags or 2;
  End;
  If ChunkId and 64 <> 0 then Begin
    Blockread (f, b, 1);
    Seek (f, Filepos (f)+b);
  End;
  If (ChunkId and 128 <> 0) and (Mapping) then Begin
    Writeln ('  Reading mapping data...');
    Getmem (Objects [Number-1].Texture, 4*Objects [Number-1].VertNum);
    For a := 1 to Objects [Number-1].FaceNum do With Objects [Number-1] do Begin
      New (Texture^ [Face^ [a]^.Poly.x]);
      New (Texture^ [Face^ [a]^.Poly.y]);
      New (Texture^ [Face^ [a]^.Poly.z]);
      Blockread (f, Texture^ [Face^ [a]^.Poly.x], 2);
      Blockread (f, Texture^ [Face^ [a]^.Poly.y], 2);
      Blockread (f, Texture^ [Face^ [a]^.Poly.z], 2);
    End;
    Objects [Number-1].Flags := Objects [Number-1].Flags or 1;
  End;
End;

{----------------------------------------------------------------------------}

Begin
  CheckBreak := FALSE;
  Writeln ('2XVO version 0.12  Written by BoRZoM');
  Writeln ('');
  If ParamCount = 0 then Begin
    Writeln ('  Usage: 3DS2XVO input.ext [scaling_factor] [output[.ext]] [options]');
    Writeln;
    Writeln ('  input.ext           object to convert / XVO to view');
    Writeln ('  scaling_factor      scaling factor, 256 to leave unchanged');
    Writeln ('  output.ext          name of output file, if extension');
    Writeln ('                       not given, the program will add one');
    Writeln ('                       optional');
    Writeln;
    Writeln ('  options             -swap      swap the normals');
    Writeln ('                       -merge     merge all objects to one');
    Writeln ('                       -mapping   save mapping coordinates');
    Writeln ('                       -preview   preview the object');
    Writeln;
    Writeln ('  supported formats   3DS, ASC, DXF, VO.');
    Writeln;
    Halt;
  End;
  Writeln ('  Free memory: ', MemAvail div 1024, 'kb');
  If (ParamCount = 1) and (ObjectType (Upper (Paramstr (1))) <> fXVO) then Begin
    Writeln ('  error: Scaling factor missing!');
    Halt;
  End;
  If ObjectType (Upper (Paramstr (1))) <> fXVO then Begin
    val (Paramstr (2), Scale, a);
    If a <> 0 then Begin
      Writeln ('  error: Invalid number!');
      Halt;
    End;
  End;
  Assign (f, ParamStr (1));
  {$I-} Reset (f, 1); {$I+}
  If IOResult <> 0 then Begin
    Writeln ('  error: File not found!');
    Halt;
  End;
  Preview := False;
  Swap    := False;
  Mapping := False;
  Merge   := False;
  Error   := False;
  fName   := '';
  For x := 3 to ParamCount do Begin
    s := Paramstr (x);
    If (s [1] = '-') then begin
      If Length (s) > 1 then Begin
        s := Upper (Copy (s, 2, Length (s)));
        Error := True;
        If s = 'PREVIEW' then Begin Preview := True; Error := False; End;
        If s = 'SWAP'    then Begin Swap    := True; Error := False; End;
        If s = 'MAPPING' then Begin Mapping := True; Error := False; End;
        If s = 'MERGE'   then Begin Merge   := True; Error := False; End;
      End else Error := True;
    End else fName := Paramstr (x);
  End;
  If Error then Begin
    Writeln ('  error: unrecognized option!');
    Halt;
  End;
  Number := 0;
  Mark (Save);
  Case ObjectType (Upper (Paramstr (1))) of
    f3DS:   ReadObject3DS;
    fASC:   ReadObjectASC;
    fDXF:   ReadObjectDXF;
    fVO:    ReadObjectVO;
    {fXVO:  ViewObject (Paramstr (1), TRUE); }
    fError: Begin
      Writeln ('  error: unrecognized format!');
      Halt;
    End;
  End;
  Close (f);
  If Number = 0 then Begin
    Writeln ('  error: No objects!');
    Halt;
  End;
  For a := 0 to Number-1 do CalculateNormals (a);
  if Merge then MergeObjects (TRUE);

  Name := fName;
  If Name = '' then Begin
    Name := Paramstr (1);
    While Pos ('\', Name) > 0 do Delete (Name, 1, Pos ('\', Name));
    If Pos (':', Name) > 0 then Delete (Name, 1, Pos (':', Name));
    Name := Copy (Name, 1, Pos ('.', Name)) + 'XVO';
  End else If Pos ('.', Name) = 0 then Name := Name + '.XVO';

  SaveXVO (Name, TRUE);
  MergeObjects (FALSE);
  If Preview then SaveXVO ('2XVO.$$$', FALSE);
  Release (Save);

  If Preview then Begin
{   ViewObject ('2XVO.$$$', FALSE); }
    Assign (f, '2XVO.$$$');
    Erase (f);
  End;
  Writeln ('  Objects saved: ', Number);
end.