#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include "clax.h"

// test program for clax preview
// loads 1.3ds in current directory
// exit with esc

void mode(int mode);
#pragma aux mode = \
 "xor ebx,ebx" \
 "xor ecx,ecx" \
 "xor edx,edx" \
 "int 10h" \
 parm [eax] modify [ebx ecx edx];

void main ()
{
  c_SCENE  *scene;
  c_OBJECT *obj;
  w_NODE   *node;
  c_LIGHT  *lit;
  c_CAMERA *cam;
  c_VECTOR  vec;
  char     *myscreen;
  int       err;
  int       i, x, y;
  float     frames, frame;

  myscreen = (char *)malloc(65536);
  clax_init (clax_calcnorm | clax_transform | clax_hierarchy);
  clax_allocscene (&scene);
  err = clax_loadworld ("1.3ds",scene);
  if (err != clax_err_ok)
    printf("error(after): %s\n",clax_geterror(err));
      else printf("ok!\n");

  err = clax_loadmotion ("1.3ds",scene);
  if (err != clax_err_ok)
    printf("error(after): %s\n",clax_geterror(err));
      else printf("ok!\n");
  clax_setactive (scene);

  clax_byname ("Camera01", &node);
  if (node) cam = (c_CAMERA *)node->object; else {
    clax_byname("rolli",&node);
    cam = (c_CAMERA *)node->object;
  }
  cam->sizeX = 320.0;
  cam->sizeY = 200.0;
  cam->aspectratio = 0.75;

  mode(0x13);
  clax_getframes(&frame, &frames);
  for (;frame<frames;frame = frame + 1.0) {
    if (inp (0x60)==1) {
      mode(0x03);
      exit(0);
    }
    clax_setframe(frame);
    clax_update();
    cam_update (cam);
    memset(myscreen,0,64000);
    for (node = scene->world; node; node=node->next) {
      if (node->type == clax_obj_object) {
        obj = (c_OBJECT *)node->object;
        for (i=0;i<obj->numverts;i++) {
          vec_copy (&obj->vert_trans[i].vert, &vec);
          vec_sub (&vec, &cam->pos, &vec);
          mat_mulvec (cam->camera_mat, &vec, &vec);
          x = 160+vec.x*cam->perspX/vec.z;
          y = 100-vec.y*cam->perspY/vec.z;
          if (x>=0 && x<320 && y>=0 && y<200 && vec.z > 0)
            myscreen[y*320+x] = 15;
        }
      } else if (node->type == clax_obj_light) {
        lit = (c_LIGHT *)node->object;
        vec_copy (&lit->pos,&vec);
        vec_sub (&vec, &cam->pos, &vec);
        mat_mulvec (cam->camera_mat, &vec, &vec);
        x = 160+vec.x*cam->perspX/vec.z;
        y = 100-vec.y*cam->perspY/vec.z;
        if (x>=0 && x<320 && y>=0 && y<200 && vec.z > 0) {
          myscreen[y*320+x] = 9;
          myscreen[y*320+x+1] = 9;
          myscreen[y*320+x+320] = 9;
          myscreen[y*320+x+321] = 9;
        }
      }
    }
    memcpy((char *)0xA0000, myscreen, 64000);
  }
  mode(0x03);
  printf("trying to free scene\n");
  clax_free_world (scene);
  clax_free_motion (scene);
  printf("OK!\n");

}

