{$G+,A+,R-,S-,O-,Q-}
unit P_CREDS;

{$DEFINE USEFILE}

Interface

procedure Credits;

Implementation

uses CRT, DOS, SOUND, vga, timer, fade;

{$I CARROT.INC}
{$L WATER}
{$L WALL}

procedure Distort (page : word); external;
procedure Display (page : word); external;
procedure DrawPage; external;

Const
  ColNum  = 128;
  Frames  = 1024;
  Frames2 = Frames div 8;
  pheight = 384;
  numL    = 4;

  Text    : Array [1..numL, 1..5] of String = (
    ('code',    'borzom', 'trex', '', ''),
    ('grafix',  'sticky', 'vlad', 'baboon', ''),
    ('objects', 'sticky', 'vlad', 'baboon', ''),
    ('music',   'mental', 'mental', 'trip', 'trip'));

Type
  Raw                 = array [0..$ffff-1] of Byte;
  Emo                 = array [0..254, 0..255] of Byte;
  SquareRootTableType = array [0..65534] of Byte;
  SquareTableType     = array [-1024..1024] of Longint;
  iArray              = array [0..0] of Integer;

var
  height         : array [0..1] of Pointer;
  Font           : array ['A'..'Z'] of Pointer;
  Pal            : array [0..767] of Byte;
  Sqr            : ^SquareTableType;
  Sqrt           : ^SquareRootTableType;
  TransformTable : ^Emo;
  DisTable       : ^Raw;
  back           : Pointer;
  vpage1,
  vpage          : Pointer;
  x, y, z        : Longint;
  Frame          : Longint;
  ang            : Integer;
  LightX, LightY : Integer;
  page           : Byte;
  lp, sp         : Integer;

function LoadCEL (n : String) : Pointer;
var
  p : Pointer;
  y,
  x : Word;
  b : Byte;
  f : File;
Begin
  Assign (f, n);
  {$I-} reset (f, 1); {$I+}
  If IOresult <> 0 then Error (e_File);
  Seek (f, 4);
  Blockread (f, b, 1);
  x := (FileSize (f)-800) div b;
  Seek (f, 800);
  Getmem (p, x*b + 4);
  MEMW [seg (p^):ofs (p^)] := b;
  MEMW [seg (p^):ofs (p^)+2] := x;
  Blockread (f, MEM [seg (p^):ofs (p^)+4], x*b, y);
  If y <> x*b then Error (e_Read);
  Close (f);
  LoadCEL := p;
End;

function Exist (n : String) : Boolean;
var
  f: File;
Begin
  Assign (f, n);
  {$I-} Reset (f, 1); {$I+}
  If IOResult=0 then Begin
    Exist := True;
    Close (f);
  End else Exist := False;
End;

function rep (s1, s2 : String) : String;
var
  x : Byte;

Begin
  x := Pos ('%', s1);
  Delete (s1, x, 1);
  Insert (s2, s1, x);
  rep := s1;
End;

procedure LoadFont (n : String);
const
  Letters : String = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var
  s    : String;
  x    : Integer;

Begin
  x := 1;
  While Exist (rep (n, Letters [x])) do Begin
    Font [Letters [x]] := LoadCEL (rep (n, Letters [x]));
    inc (x);
  End;
End;

procedure ReleaseFont;
var
  c: Char;

Begin
  For c := 'A' to 'Z' do Freemem (Font [c],
    memw [seg (font [c]^):ofs (font [c]^)]*
    memw [seg (font [c]^):ofs (font [c]^)+2]+4);
End;

procedure DrawLetter (x, y : Integer; c : Char);
var
  a, b : Integer;
  fp   : Pointer;
  xs,
  ys   : Integer;
  i    : Byte;

Begin
  fp := Font [c];
  xs := memw [seg (fp^):ofs (fp^)+2];
  ys := memw [seg (fp^):ofs (fp^)];
  for a := 0 to xs-1 do
    for b := 0 to ys-1 do begin
      i := mem [seg (fp^):ofs (fp^)+4+(b*xs+a)];
      if i > 0 then
        mem [seg(vpage^):(y+b)*160+x+a] := i;
    End;
End;

procedure WriteString (yy : Integer; s : String);
var
  x, y, z : Integer;
  cx, cy  : Integer;

begin
  cx := 0;
  cy := 0;
  For x := 1 to length (s) do begin
    s [x] := upcase (s [x]);
    if s [x] <> ' ' then
      cx := cx + memw [seg (font [s[x]]^):ofs (font [s[x]]^)+2]
        else cx := cx + 10;
  End;
  cx := 80 - (cx div 2);
  y := 0;
  for x := 1 to length (s) do Begin
    if s [x] <> ' ' then begin
      cy := 100 - (memw [seg (font [s[x]]^):ofs (font [s[x]]^)+2]) div 2;
      DrawLetter (cx+y, yy, s [x]);
      y := y + memw [seg (font [s[x]]^):
                     ofs (font [s[x]]^)+2];
    End else y := y + 10;
  End;
End;


procedure Create_SquareRootTable;
var
  a, b, c, i : Longint;

Begin
  i := 0; a := 0; b := 1; c := 0;
  Repeat
   sqrt ^[i]:=a;
   inc (c);
   If c=b then Begin
     c := 0;
     Inc (b, 2);
     Inc (a);
   End;
   inc (i);
  Until i=65532;
End;

procedure Create_SquareTable;
var
  a, b, i : Longint;

Begin
  a := 0; b := 1;
  For i := 0 to 1024 do Begin
    Sqr^ [i] := a;
    Sqr^ [0-i] := Sqr^ [i];
    inc (a, b);
    inc (b, 2);
  End;
End;

Procedure CreateTable;
var
  a, b, c            : Word;
  CurColor, PalIndex : Word;
  Dist, TempDist     : Word;
  Closest            : Word;
  Red, Green, Blue   : Byte;

Begin
  {$IFNDEF USEFILE}
  for b := 0 to ColNum-1 do
    for a := 0 to 255 do Begin
      c := a+a+a+1;
      Red   := Pal [c]*b   div ColNum;
      Green := Pal [c+1]*b div ColNum;
      Blue  := Pal [c+2]*b div ColNum;
      Dist  := $FFFF;
      PalIndex :=0;
      Closest  :=0;
      For CurColor:=0 to 255 Do Begin
         Asm
          Lea Bx,Pal
          Add Bx,PalIndex
          Mov Al,[Bx]
          Sub Al,Red
          Cbw
          Xor Al,Ah
          Sub Al,Dh
          Mov Cl,Al
          Inc Bx
          Mov Al,[Bx]
          Sub Al,Green
          Cbw
          Xor Al,Ah
          Sub Al,Dh
          Add Cl,Al
          Inc Bx
          Mov Al,[Bx]
          Sub Al,Blue
          Cbw
          Xor Al,Ah
          Sub Al,Dh
          Add Cl,Al
          Mov TempDist,Cx
        End;
        If TempDist<Dist then Begin
          Closest := CurColor;
          Dist := TempDist;
          If Dist=0 then Break;
        End;
        Inc (PalIndex, 3);
      End;
      TransformTable^ [b, a] := Closest;
    End;
  {$ENDIF}
End;

Procedure CreateDisTable;
var
  A, B : Longint;
  T    : Longint;
  C    : Word;
  L    : Word;
  F    : File;
Begin
  {$IFNDEF USEFILE}
  C := 0;
  FillChar (DisTable^, 16000, 0);
  for B := 0 to 99 do
    for A := 0 to 159 do Begin
      T := Longint (Sqr^ [a])+Longint (Sqr^ [b]);
      If T>65000 then DisTable^ [C] := 127 else DisTable^ [C]:= Sqrt^ [T] div 2;
      inc (C);
    End;
  Assign (f, f_DisTable);
  Rewrite (f, 1);
  Blockwrite (f, DisTable^, 16000);
  Close (f);
  Assign (f, f_TransTable);
  Rewrite (f, 1);
  Blockwrite (f, TransformTable^, 65535);
  Close (f);
  {$ELSE}
  Assign (f, f_DisTable);
  Reset (f, 1);
  Blockread (f, DisTable^, 16000);
  Close (f);
  Assign (f, f_TransTable);
  Reset (f, 1);
  Blockread (f, TransformTable^, 65535);
  Close (f);
  {$ENDIF}
End;

Procedure CreatePage; Assembler;
Asm
  Les  Ax, Vpage1
  Mov  Ax, Es
  Les  Bx, TransformTable
  Mov  Bx, Es
  Les  Cx, DisTable
  Mov  Cx, Es
  Les  Dx, Vpage
  Mov  Dx, Es
  Mov  Si, LightX
  Mov  Di, LightY
  Call DrawPage
End;

procedure distort (x, y: integer);
begin
  iarray (height [page]^)[100*x+y] := pheight;
  iarray (height [page]^)[100*(x-1)+y] := pheight shr 1;
  iarray (height [page]^)[100*(x+1)+y] := pheight shr 1;
  iarray (height [page]^)[100*x+y+100] := pheight shr 1;
  iarray (height [page]^)[100*x+y-100] := pheight shr 1;
end;

function max (b : Word) : Byte;
Begin
  if b>63 then b := 63;
  max := b;
End;

procedure _sync; far;
Begin
  inc (Frame);
End;

Procedure Credits;
Begin
  Getmem (height [1], 32768);
  Getmem (height [0], 32768);
  Getmem (back, 16384);
  Getmem (vPage, 16384);
  Getmem (DisTable, 32768);
  Getmem (TransformTable, 65535);
  Getmem (vPage1, 16384);
  {$IFNDEF USEFILE}
  Getmem (Sqrt, 65535);
  Getmem (Sqr, Sizeof (SquareTableType));
  Create_SquareRootTable;
  Create_SquareTable;
  {$ENDIF}
  Setmode (g160x100, 160, 100, 1);

  Fillchar (vPage^, 16000, 0);
  Fillchar (Back^, 16000, 255);
  Fillchar (Height [0]^, 32000, 0);
  Fillchar (Height [1]^, 32000, 0);

  For x := 1 to 255 do Begin
    pal [x*3]   := (255-x) div 5;
    pal [x*3+1] := (255-x) div 5;
    pal [x*3+2] := max((255-x) div 3);
  End;
  Frame := 0;
  InitPalette (Pal);
  ClearPage (vPage);
  CreateTable;
  CreateDisTable;
  LoadFont (f_Font1);

{  tmrSyncSCR (sync, @_sync, NIL, NIL); }
  lp := 1;
  sp := 1;
  while (Frame < Frames) do begin
    inc(frame);
    If Frame < 64 then FadePalette (Frame) else
     If Frame > Frames-64 then FadePalette (64-(Frame-(Frames-64))) else
       FadePalette (64);
    Page := Page xor 1;
    Ang  := Frame shr 1 and 1023;
    If Ang < Frames2 then Begin
      x := 80+Round (cos (ang/25)*50);
      y := 50+Round (sin (ang/25)*40);
    End else If Ang < Frames2*2 then Begin
      x := 80-Round (cos (ang/25)*50);
      y := 50+Round (sin (ang/25)*40);
    End else If Ang < Frames2*3 then Begin
      x := 80+Round (cos (ang/4)*50);
      y := 50+Round (sin (ang/4)*40);
    End else If Ang < Frames2*4 then Begin
      x := random (140)+10;
      y := random (80)+10;
    End;
    Distort (x, y);
    Distort (160-x, 200-y);
    Display (Page);
    LightX := Round (80+49*Sin (7*Frame*pi/240));
    LightY := Round (50+49*Cos (7*Frame*pi/240));
    lp := (Frame div (Frames div NumL))+1;
    sp := (Frame div NumL) div 32 mod 2;
    writestring (10, text [lp, 1]);
    writestring (40, text [lp, sp+2]);
    writestring (70, text [lp, sp+2+2]);
    CreatePage;              { LIGHTSPOT }
    ViewPage (vpage1);
  End;
{  tmrStopSCRsync; }
End;

End.