unit p_fish;

interface

procedure fish;

implementation

uses sound, vga, vgafx, vgagif, vga3d, timer;

{$I CARROT.INC}
type
  PLongArray = ^TLongArray;
  TLongArray = Array [0..0] of Longint;

  LMorph    = Object
    v1, v2, Result : PLongArray;
    Stages, Size   : Word;

    Constructor Init (_Stages, _Size : Word);
    Procedure   Process (Stage : Word);
    Destructor  Done;
  End;
Constructor LMorph.Init;
Begin
  Size := _Size;
  Stages := _Stages;
  Fillchar (Result^, Size*Sizeof(LongInt), 0);
End;

Procedure LMorph.Process;
var
 i    : Integer;

Begin
  For i := 0 to Size-1 do
    Result^ [i] := (v1^ [i]- v2^ [i])*Stage div Stages+ v2^ [i];
End;

Destructor LMorph.Done;
Begin
End;

var
 b,p,s:pointer;
 x,y,z:integer;
 m1,m2,m3:pointer;
 map1:pointer;
 v:vector;
 ra:integer;
 vertnum:word;
 m:lmorph;
 ms,md:integer;
 frame:integer;
 sint:array[0..255]of integer;

procedure moved(p1,p2:pointer);assembler;
asm
 push ds
 lds si,p1
 les di,p2
 mov cx,16000
 db $66; rep movsw
 pop ds
end;

procedure loadvertex(n:string;var p:pointer);
var
  fl      : File;
  t       : integer;
  Count   : Integer;
  offs    : Word;
  Buffer  : Array [1..2048] of integer;

  Function GetWord : Integer;
  var
    w : Word;
  Begin
      If Offs > 2048 then Begin
        Offs := 1;
        Blockread (fl, Buffer, 4096, w);
      End;
      GetWord := Buffer [Offs];
      Inc (Offs);
  End;
var
  localvert:PCoordList;
  xx,yy,zz:longint;

Begin
  Assign (fl, n);
  {$I-} Reset (fl, 1); {$I+}
  Seek (fl, 7);
  Offs := 4096;
  VertNum := GetWord;
  GetWord;
  Getmem (localvert, Sizeof(Point3D)*VertNum);
  For Count := 0 to VertNum-1 do Begin
    LocalVert^[Count].x := GetWord;
    LocalVert^[Count].y := GetWord;
    LocalVert^[Count].z := GetWord;
    GetWord;GetWord;GetWord;
  End;
  xx := 0; yy := 0; zz := 0;
  For count := 0 to VertNum-1 do Begin
    Inc (xx, LocalVert^[count].x);
    Inc (yy, LocalVert^[count].y);
    Inc (zz, LocalVert^[count].z);
  End;
  xx := xx div VertNum;
  yy := yy div VertNum;
  zz := zz div VertNum;
  For count := 0 to VertNum-1do Begin
    Dec (LocalVert^[count].x, xx);
    Dec (LocalVert^[count].y, yy);
    Dec (LocalVert^[count].z, zz);
  End;
  Close (fl);
  p := localvert;
End;

procedure _Sync; far;
begin
 inc(frame,2);
End;

procedure fish;
begin
  SetMode (g320x200, 320, 200, 1);
  getmem(p,65535);
  map1:=loadgif('data\fish.gif');
  b:=loadgif('data\backgr2.gif');
  blankpalette;
  InitFadeTo (gifpalette);
  viewpage(b);
  while fadeto do waitsync;
  v.Init (nil, 'data\fish1.xvo');
  v.gravity (x, y, z);
  v.move (x, y, z);
  v.SetPage (p);
  v.SetLight (0, 0, 512);
  v.SetLocation (0, 0, 512);
  v.SetMaterial (sTexture, 128, map1);
  v.SetAngle (0);
  loadvertex('data\fish1.xvo',m1);
  loadvertex('data\fish2.xvo',m2);
  m.v1 := m1;
  m.v2 := m2;
  m3 := v.vectorobject.localvert;
  m.result := m3;
  m.init (32, vertnum*3);

  maxx:=318;maxy:=198;
  frame:=0;
  ms:=1;
  md:=3;
  ra:=0;
  tmrSyncSCR (sync, @_sync, NIL, NIL);
  while frame<1400 do begin
    ms:=ms+md;
    if (ms=31)or(ms=1) then md:=-md;
    m.process(ms);
    x:=frame;
    if (frame>512)and(frame<512+256)then inc(ra);
    moved(b,p);
    if frame>512+128 then v.setlocation(-(x-768),0,512) else
      v.setlocation(x-512,0,512);
    v.setrotation(384,(ra*4)and 511,0);
    v.render;
    v.project;
    viewpage(p);
  end;
  v.done;
  tmrStopSCRsync;
  initfade;
  while fadeout do waitsync;
end;

end.