{$G+,A+,R-,S-,O-,V+}
unit P_HYDRA;

interface

procedure hydra;

implementation

Uses VGA, VGA3D, VGAVESA, VGAGIF, DOS, dtexture,CRt, SOUND, TIMER, FADE, VGAFX;

{$I CARROT.INC}

const
  nframes = 1024;

type
  oneframe = record
    ax,ay,az,
    tx,ty,tz,
    mv : integer;
  end;

  pframes =^tframes;
  tframes = array[0..0] of oneframe;

var
  x, y, z : Integer;
  v       : Vector;
  w:integer;
  map1,map2:pointer;
  frames   : pframes;
  p,p2     : Pointer;
  FaceNum,
  VertNum  : Integer;
  h1,
  h2,
  h3,
  n1,n2,n3 : Pointer;
  kombat   : Pointer;

type
  PLongArray = ^TLongArray;
  TLongArray = Array [0..0] of Longint;

  LMorph    = Object
    v1, v2, Result : PLongArray;
    Stages, Size   : Word;

    Constructor Init (_Stages, _Size : Word);
    Procedure   Process (Stage : Word);
    Destructor  Done;
  End;

procedure loadvertex(n:string;var p:pointer);
var
  fl      : File;
  t       : integer;
  Count   : Integer;
  offs    : Word;
  Buffer  : Array [1..2048] of integer;

  Function GetWord : Integer;
  var
    w : Word;
  Begin
      If Offs > 2048 then Begin
        Offs := 1;
        Blockread (fl, Buffer, 4096, w);
      End;
      GetWord := Buffer [Offs];
      Inc (Offs);
  End;
var
  localvert:PCoordList;
  xx,yy,zz:longint;

Begin
  Assign (fl, n);
  {$I-} Reset (fl, 1); {$I+}
  Seek (fl, 7);
  Offs := 4096;
  VertNum := GetWord;
  GetWord;
  Getmem (localvert, Sizeof(Point3D)*VertNum);
  For Count := 0 to VertNum-1 do Begin
    LocalVert^[Count].x := GetWord;
    LocalVert^[Count].y := GetWord;
    LocalVert^[Count].z := GetWord;
    GetWord;GetWord;GetWord;
  End;
  xx := 0; yy := 0; zz := 0;
  For count := 0 to VertNum-1 do Begin
    Inc (xx, LocalVert^[count].x);
    Inc (yy, LocalVert^[count].y);
    Inc (zz, LocalVert^[count].z);
  End;
  xx := xx div VertNum;
  yy := yy div VertNum;
  zz := zz div VertNum;
  For count := 0 to VertNum-1do Begin
    Dec (LocalVert^[count].x, xx);
    Dec (LocalVert^[count].y, yy);
    Dec (LocalVert^[count].z, zz);
  End;
  Close (fl);
  p := localvert;
End;

procedure loadnormal (n:string;var p:pointer);
var
  fl      : File;
  t       : Word;
  Count   : Integer;
  offs    : Word;
  Buffer  : Array [1..2048] of Word;

  Function GetWord : Integer;
  var
    w : Word;
  Begin
      If Offs > 2048 then Begin
        Offs := 1;
        Blockread (fl, Buffer, 4096, w);
      End;
      GetWord := Buffer [Offs];
      Inc (Offs);
  End;

var
  localvert:PCoordList;

Begin
  Assign (fl, n);
  {$I-} Reset (fl, 1); {$I+}
  Seek (fl, 7);
  Offs := 4096;
  VertNum := GetWord;
  FaceNum := GetWord;
  Getmem (localvert, Sizeof(Point3D)*VertNum);
  For Count := 0 to FaceNum-1 do Begin
    GetWord;GetWord;GetWord;
    LocalVert^[Count].x := GetWord;
    LocalVert^[Count].y := GetWord;
    LocalVert^[Count].z := GetWord;
  End;
  Close (fl);
  p := localvert;
End;

Constructor LMorph.Init;
Begin
  Size := _Size;
  Stages := _Stages;
  Fillchar (Result^, Size*Sizeof(LongInt), 0);
End;

Procedure LMorph.Process;
var
 i    : Integer;

Begin
  For i := 0 to Size-1 do
    Result^ [i] := (v1^ [i]- v2^ [i])*Stage div Stages+ v2^ [i];
End;

Destructor LMorph.Done;
Begin
End;

procedure moved(p1,p2:pointer);assembler;
asm
 push ds
 lds si,p1
 les di,p2
 mov cx,16000
 db $66; rep movsw
 pop ds
end;

var m,nm,pm,nm2:lmorph;
    mv:word;
    md:integer;
    bc:pointer;
    cframe,
    frame:integer;

procedure _Sync; far;
begin
 inc(cframe);
End;

function LoadCEL (n : String) : Pointer;
var
  p : Pointer;
  x : Word;
  b : Byte;
  f : File;
Begin
  Assign (f, n);
  {$I-} reset (f, 1); {$I+}
  If IOresult <> 0 then Error (e_File);
  Seek (f, 4);
  Blockread (f, b, 1);
  x := (FileSize (f)-800) div b;
  Seek (f, 800);
  Getmem (p, x*b + 4);
  MEMW [seg (p^):ofs (p^)] := b;
  MEMW [seg (p^):ofs (p^)+2] := x;
  Blockread (f, MEM [seg (p^):ofs (p^)+4], x*b, y);
  If y <> x*b then Error (e_Read);
  Close (f);
  LoadCEL := p;
End;

procedure putImage (x, y : Integer; fp : Pointer);
var
  a, b : Integer;
  xs,
  ys   : Integer;
  i    : Byte;

Begin
  xs := memw [seg (fp^):ofs (fp^)+2];
  ys := memw [seg (fp^):ofs (fp^)];
  for a := 0 to xs-1 do
    for b := 0 to ys-1 do begin
      i := mem [seg (fp^):ofs (fp^)+4+(b*xs+a)];
      if (i > 0)and(x+a<320)and(x+a>=0) then
        mem [seg(p^):(y+b)*320+x+a] := i;
    End;
End;

procedure hydra;
Begin
  SetMode (g320x200, 320, 200, 1);     { unchained 320x200x256 mode }
  GetMem (p, PageSize);
  Randomize;
  x := random (64); y := random (64); z := random (64);
  map1 := loadGIF (f_Phng);
  bc := loadGIF (f_Phngback);
  setpalette (GIFpalette);
  maxx:=320;maxy:=200;
  gf_pixel (bc^);
  maxx:=318;maxy:=198;
  v.Init (nil,f_m1);
  v.gravity(x,y,z);
  v.move(x,y,z);
  v.SetPage (p);
  v.SetLight (0, 0, 512);
  v.SetLocation (0, 0, 300);
  v.SetMaterial (sEnvironment, 128, map1);
  v.SetAngle (0);
  dec (maxx); dec (maxy);
  getmem(frames,2048*sizeof(oneframe));
  for x:=0 to 255 do begin
    frames^[x].ax := x and 511;
    frames^[x].ay := x and 511;
    frames^[x].az := x and 511;
    frames^[x].tx := 0;
    frames^[x].ty := 255-x;
    frames^[x].tz := 512;
    frames^[x].mv := 1;
  end;
  for x:=256 to 256+255 do begin
    frames^[x].ax := x and 511;
    frames^[x].ay := x and 511;
    frames^[x].az := x and 511;
    frames^[x].tx := 0;
    frames^[x].ty := 0;
    frames^[x].tz := 512;
    frames^[x].mv := 1;
  end;
  for x:=256+255+1 to 256+255+32 do begin
    frames^[x].ax := x and 511;
    frames^[x].ay := x and 511;
    frames^[x].az := x and 511;
    frames^[x].tx := 0;
    frames^[x].ty := 0;
    frames^[x].tz := 512;
    frames^[x].mv := x-(256+255+1);
  end;
  for x:=256+255+33 to 256+255+17+238 do begin
    frames^[x].ax := x and 511;
    frames^[x].ay := x and 511;
    frames^[x].az := x and 511;
    frames^[x].tx := 0;
    frames^[x].ty := 0;
    frames^[x].tz := 512;
    frames^[x].mv := 31;
  end;
  y:=0;
  for x:=256+255+17+238 to 256+255+17+238+255 do begin
    y:=y+2;
    frames^[x].ax := x and 511;
    frames^[x].ay := x and 511;
    frames^[x].az := x and 511;
    frames^[x].tx := 0;
    frames^[x].ty := -y;
    frames^[x].tz := 512;
    frames^[x].mv := 31;
  end;
  kombat := LoadCEL ('KOMBAT.CEL');
  loadvertex(f_m1,h1);
  loadvertex(f_m2,h2);
  m.v1 := h1;
  m.v2 := h2;
  h3:= v.vectorobject.localvert;
  m.result := h3;
  m.init (32, vertnum*3);

  loadnormal(f_m1,h1);
  loadnormal(f_m2,h2);
  nm.v1 := h1;
  nm.v2 := h2;
  h3 := v.vectorobject.vertnorms;
  nm.result := h3;
  nm.init (32, vertnum*3);
  v.setangle(-512);
  md:=1;
  mv:=0;
  w:=0;
  tmrSyncSCR (sync, @_sync, NIL, NIL);
  m.process (1);
  nm.process (1);
  frame:=0;
  cframe:=0;
  while cframe<1021 do begin
    frame:=cframe;
    moved (bc,p);
    v.SetLocation (frames^[frame].tx,frames^[frame].ty,frames^[frame].tz);
    v.SetRotation (frames^[frame].ax,frames^[frame].ay,frames^[frame].az);
    m.process (frames^[frame].mv);
    nm.process (frames^[frame].mv);
    v.Render;
    v.Project;
    if (cframe>=448)and(cframe<=448+50+18+18) then begin
      x:=320-55;
      if (cframe>=448)and(cframe<=448+18) then x:=320-(cframe-448)*3;
      if (cframe>=448+50+18)and(cframe<=448+50+18+18) then x:=320-55+(cframe-(448+50+18))*3;
      putimage(x, 200-memw [seg (kombat^):ofs (kombat^)],kombat);
    end;
    viewpage (p);
  End;
  tmrStopSCRsync;
  v.Done;
  initpalette(gifpalette);
  for x:=63 downto 0 do begin
    fadepalette(x);
    waitsync;
  end;
End;

end.