{$G+,A+,R-,S-,O-,Q-}
unit P_INTRO;

Interface

procedure Introduction;

Implementation

uses CRT, DOS, Sound, VGA, VGAGIF, VGA3D, TIMER, FADE, FLCUNIT4, FALL;

{$I CARROT.INC}

const
  Frames = 2048;
  CurrentPage : Word = 0;
  NumText   = 9;
  TextList  : Array [1..NumText, 1..3] of String [40] = (
    ('tatoo', 'present', ''),
    ('a new demo', '', ''),
    ('starring', 'borzom', 'as borzol'),
    ('trex', 'as drex', ''),
    ('hex', 'as keks', ''),
    ('vlad', 'as blad', ''),
    ('mental trip', 'as dental creep', ''),
    ('sticky baboon', 'as kinky racoon', ''),
    ('and', 'phanatik', 'as bombastik'));

type
  Screen = Array [0..199, 0..319] of Byte;

var
  font : Array ['A'..'Z'] of Pointer;
  sv   : Pointer;
  f    : file;
  b    : Byte;
  x, y,
  z    : Integer;
  p    : Pointer;
  pal1 : Array [0..767] of Byte;
  num  : Integer;
  map  : Pointer;
  v    : Vector;
  frame: Word;
  anim : Pointer;
  curl,
  curs : Integer;

function LoadCEL (n : String) : Pointer;
var
  p : Pointer;
  x : Word;
  b : Byte;

Begin
  Assign (f, n);
  {$I-} reset (f, 1); {$I+}
  If IOresult <> 0 then Error (e_File);
  Seek (f, 4);
  Blockread (f, b, 1);
  x := (FileSize (f)-800) div b;
  Seek (f, 800);
  Getmem (p, x*b + 4);
  MEMW [seg (p^):ofs (p^)] := b;
  MEMW [seg (p^):ofs (p^)+2] := x;
  Blockread (f, MEM [seg (p^):ofs (p^)+4], x*b, y);
  If y <> x*b then Error (e_Read);
  Close (f);
  LoadCEL := p;
End;

function Exist (n : String) : Boolean;
var
  f: File;
Begin
  Assign (f, n);
  {$I-} Reset (f, 1); {$I+}
  If IOResult=0 then Begin
    Exist := True;
    Close (f);
  End else Exist := False;
End;

function rep (s1, s2 : String) : String;
var
  x : Byte;

Begin
  x := Pos ('%', s1);
  Delete (s1, x, 1);
  Insert (s2, s1, x);
  rep := s1;
End;

procedure LoadFont (n : String);
const
  Letters : String = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var
  s    : String;
  x    : Integer;

Begin
  For x := 1 to Length (Letters) do
    Font [Letters [x]] := LoadCEL (rep (n, Letters [x]));
End;

procedure ReleaseFont;
var
  c: Char;

Begin
  For c := 'A' to 'Z' do Freemem (Font [c],
    memw [seg (font [c]^):ofs (font [c]^)]*
    memw [seg (font [c]^):ofs (font [c]^)+2]+4);
End;

procedure DrawLetter (x, y : Integer; c : Char);
var
  a, b : Integer;
  fp   : Pointer;
  xs,
  ys   : Integer;
  i    : Byte;

Begin
  fp := Font [c];
  xs := memw [seg (fp^):ofs (fp^)+2];
  ys := memw [seg (fp^):ofs (fp^)];
  for a := 0 to xs-1 do
    for b := 0 to ys-1 do begin
      i := mem [seg (fp^):ofs (fp^)+4+(b*xs+a)];
      if i > 0 then
        mem [seg(p^):(y+b)*320+x+a] := i;
    End;
End;

function Max (b : Byte) : Byte;
Begin
  If b > 15 then b := 15;
  Max := b;
End;

{****************************************************************************}

procedure WriteString (y_: integer; s : String);
var
  x, y, z : Integer;
  cx, cy  : Integer;

begin
  cx := 0;
  cy := 0;
  For x := 1 to length (s) do begin
    s [x] := upcase (s [x]);
    if s [x] <> ' ' then
      cx := cx + memw [seg (font [s[x]]^):ofs (font [s[x]]^)+2]
        else cx := cx + 10;
  End;
  cx := 160 - (cx div 2);
  y := 0;
  for x := 1 to length (s) do Begin
    if s [x] <> ' ' then begin
      cy := (100 - (memw [seg (font [s[x]]^):ofs (font [s[x]]^)+2]) div 2) div 2-35;
      DrawLetter (cx+y+random(3), y_+cy+random(3), s [x]);
      y := y + memw [seg (font [s[x]]^):
                     ofs (font [s[x]]^)+2];
    End else y := y + 10;
  End;
End;

procedure _sync; far;
begin
  inc (Frame);
end;

procedure DrawText;
var
 a: byte;
Begin
  curl := (frame div (frames div NumText))+1;
  for a := 1 to 3 do
    WriteString (a*45, TextList [curl, a]);
End;

procedure ReadTatooRGB;
var
  x, y, z: Integer;
  f      : File;
  Header : Array [0..17] Of Byte;
  HeaderS: Word;
  ScanLine : Array[0..3839] Of Byte;

Begin
  Assign (f, f_Tatoo);
  Reset (f, 1);
  BlockRead (f, Header,18);
  HeaderS := 18+Header[5]+256*Header[6];
  Seek (f, HeaderS);

  If (Header[17] And 32)>0 Then Begin
    For Y:=0 To 199 Do Begin
      BlockRead(f, ScanLine, 3*320);
      For X:=0 To 319 Do Begin
        Rgbpix (x, y, ScanLine[x*3] shr 4,
                      ScanLine[x*3+1] shr 4,
                      ScanLine[x*3+2] shr 4);
      End;
    End;
  End
  Else Begin
    For Y:=199 DownTo 0 Do Begin
      BlockRead(f,ScanLine,3*320);
      For X:=0 To 319 Do Begin
        Rgbpix (x, y, ScanLine[x*3] shr 4,
                      ScanLine[x*3+1] shr 4,
                      ScanLine[x*3+2] shr 4);
      End;
    End;
  End;
  Close (f);
End;

procedure Introduction;
Begin
  mark (sv);
  InitPaletteRGB;
  InitPalette (pal1);
  BlankPalette;
  ReadTatooRGB;
  tmrSyncSCR (sync, @_syncpage, NIL, NIL);

  InitFadeTo (pal1);
  For x := 0 to 64 do Begin
    FadePalette (x);
    WaitSync;
  End;
  Delay (4096);
  For x := 64 downto 0 do Begin
    FadePalette (x);
    WaitSync;
  End;
  tmrStopSCRsync;
  SetMode (g320x200, 320, 200, 1); maxx := 318; maxy := 198;
  map := LoadGIF (f_BallTex);
  Getmem (p, 65535);
  BlankPalette;
  v.Init (nil, f_BallVec);
  v.gravity (x, y, z);
  v.move (x, y, z);
  v.SetPage (p);
  v.SetLight (0, 0, 512);
  v.SetLocation (0, 0, 512);
  v.SetMaterial (sTexture, 128, map);
  v.SetAngle (0);
  Clearpage (p);
  InitFadeTo (GIFPalette);
  LoadFont (f_Font0);
  tmrSyncSCR (sync, @_sync, NIL, NIL);
  Frame := 0;
  InitPalette (GIFPalette);
  While Frame < Frames do Begin
    If Frame < 64 then FadePalette (Frame) else
     If Frame > Frames-64 then FadePalette (64-(Frame-(Frames-64))) else
       FadePalette (64);
    v.SetRotation (Frame and 511, Frame and 511, Frame and 511);
    v.Render;
    v.Project;
    DrawText;
    Viewpage (p);
    Clearpage (p);
  End;
  FadePalette (0);
  ClearPage (@VGA.Screen);
  tmrStopSCRsync;
  Freemem (p, 65535);
  Freemem (map, 65535);
  v.Done;
  ReleaseFont;
  LoadFLC (f_MouseAnim, anim, 0, 0);
  PhisicalScreenWidth := 320;
  ShowFLC (anim, 0, GetLastFrameNumber (anim)-19, 45);
  getmem (p, 65535);
  Move (MEM [$A000:0], p^, 64000);
  map := LoadGIF (f_Title);
  SetPalette (GIFPalette);
  FLCUNIT4.TargetSegment := seg (P^);
  For z := 0 to 19 do Begin
    if z < 18 then
{      ShowFLC (anim, GetLastFrameNumber (anim)-19+z+1, GetLastFrameNumber (anim)-19+z+1, 0) }
        else ClearPage (p);
    Move (mem [seg (map^):(199-(z*10))*320],
          p^, (z*10)*320);
    ViewPage (p);
    Delay (10);
    WaitSync;
  End;
  ReleaseFLC (anim);
  Release (sv);
  Delay (2048);
  PolyFall;
End;

{****************************************************************************}

End.