unit p_shop;

interface

procedure shop;

implementation

uses sound, vga, vgafx, vgagif, vga3d, timer;

{$I CARROT.INC}
type
  PLongArray = ^TLongArray;
  TLongArray = Array [0..0] of Longint;

  LMorph    = Object
    v1, v2, Result : PLongArray;
    Stages, Size   : Word;

    Constructor Init (_Stages, _Size : Word);
    Procedure   Process (Stage : Word);
    Destructor  Done;
  End;
Constructor LMorph.Init;
Begin
  Size := _Size;
  Stages := _Stages;
  Fillchar (Result^, Size*Sizeof(LongInt), 0);
End;

Procedure LMorph.Process;
var
 i    : Integer;

Begin
  For i := 0 to Size-1 do
    Result^ [i] := (v1^ [i]- v2^ [i])*Stage div Stages+ v2^ [i];
End;

Destructor LMorph.Done;
Begin
End;

var
 b,p,s:pointer;
 x,y,z:integer;
 m1,m2,m3:pointer;
 map1:pointer;
 v:vector;
 vertnum:word;
 m:lmorph;
 ms,md:integer;
 frame:integer;

function LoadCEL (n : String) : Pointer;
var
  p : Pointer;
  x : Word;
  b : Byte;
  f : file;
  y : word;
Begin
  Assign (f, n);
  {$I-} reset (f, 1); {$I+}
  If IOresult <> 0 then Error (e_File);
  Seek (f, 4);
  Blockread (f, b, 1);
  x := (FileSize (f)-800) div b;
  Seek (f, 800);
  Getmem (p, x*b + 4);
  MEMW [seg (p^):ofs (p^)] := b;
  MEMW [seg (p^):ofs (p^)+2] := x;
  Blockread (f, MEM [seg (p^):ofs (p^)+4], x*b, y);
  If y <> x*b then Error (e_Read);
  Close (f);
  LoadCEL := p;
End;

procedure moved(p1,p2:pointer);assembler;
asm
 push ds
 lds si,p1
 les di,p2
 mov cx,16000
 db $66; rep movsw
 pop ds
end;

procedure loadvertex(n:string;var p:pointer);
var
  fl      : File;
  t       : integer;
  Count   : Integer;
  offs    : Word;
  Buffer  : Array [1..2048] of integer;

  Function GetWord : Integer;
  var
    w : Word;
  Begin
      If Offs > 2048 then Begin
        Offs := 1;
        Blockread (fl, Buffer, 4096, w);
      End;
      GetWord := Buffer [Offs];
      Inc (Offs);
  End;
var
  localvert:PCoordList;
  xx,yy,zz:longint;

Begin
  Assign (fl, n);
  {$I-} Reset (fl, 1); {$I+}
  Seek (fl, 7);
  Offs := 4096;
  VertNum := GetWord;
  GetWord;
  Getmem (localvert, Sizeof(Point3D)*VertNum);
  For Count := 0 to VertNum-1 do Begin
    LocalVert^[Count].x := GetWord;
    LocalVert^[Count].y := GetWord;
    LocalVert^[Count].z := GetWord;
    GetWord;GetWord;GetWord;
  End;
  xx := 0; yy := 0; zz := 0;
  For count := 0 to VertNum-1 do Begin
    Inc (xx, LocalVert^[count].x);
    Inc (yy, LocalVert^[count].y);
    Inc (zz, LocalVert^[count].z);
  End;
  xx := xx div VertNum;
  yy := yy div VertNum;
  zz := zz div VertNum;
  For count := 0 to VertNum-1do Begin
    Dec (LocalVert^[count].x, xx);
    Dec (LocalVert^[count].y, yy);
    Dec (LocalVert^[count].z, zz);
  End;
  Close (fl);
  p := localvert;
End;
procedure _Sync; far;
begin
 inc(frame);
End;

procedure putImage (x, y : Integer; fp : Pointer);
var
  a, b : Integer;
  xs,
  ys   : Integer;
  i    : Byte;

Begin
  xs := memw [seg (fp^):ofs (fp^)+2];
  ys := memw [seg (fp^):ofs (fp^)];
  for a := 0 to xs-1 do
    for b := 0 to ys-1 do begin
      i := mem [seg (fp^):ofs (fp^)+4+(b*xs+a)];
      if (i > 0)and(x+a<320)and(x+a>=0) then
        mem [seg(p^):(y+b)*320+x+a] := i;
    End;
End;

procedure shop;

begin
  SetMode (g320x200, 320, 200, 1);
  getmem(p,65535);
  b:=loadgif('data\sell.gif');
  s:=loadcel('data\sell.cel');
  map1:=loadgif('data\money2.gif');
  setpalette(gifpalette);
  gf_zoom (b^);

  v.Init (nil, 'data\money3.xvo');
  v.gravity (x, y, z);
  v.move (x, y, z);
  v.SetPage (p);
  v.SetLight (0, 0, 512);
  v.SetLocation (-100, 0, 768);
  v.SetMaterial (sTexture, 128, map1);
  v.SetAngle (-512);

  loadvertex('data\money3.xvo',m1);
  loadvertex('data\money2.xvo',m2);
  m.v1 := m1;
  m.v2 := m2;
  m3 := v.vectorobject.localvert;
  m.result := m3;
  m.init (32, vertnum*3);

  maxx:=318;maxy:=198;
  frame:=0;
  ms:=1;
  md:=1;
  tmrSyncSCR (sync, @_sync, NIL, NIL);
  while frame<memw [seg (s^):ofs (s^)+2]*4 do begin
   ms:=ms+md;
   if (ms=31)or(ms=1) then md:=-md;
   m.process(ms);
   x:=frame;
   moved(b,p);
   if (x>memw [seg (s^):ofs (s^)+2])and(x<memw [seg (s^):ofs (s^)+2]*2) then
     putimage(x-memw [seg (s^):ofs (s^)+2]*2,200-memw [seg (s^):ofs (s^)],s);
   if (x>=memw [seg (s^):ofs (s^)+2]*2)and(x<=memw [seg (s^):ofs (s^)+2]*3) then
     putimage(0,200-memw [seg (s^):ofs (s^)],s);
   if (x>=memw [seg (s^):ofs (s^)+2]*3) then
     putimage(-(x-memw [seg (s^):ofs (s^)+2]*3),200-memw [seg (s^):ofs (s^)],s);
    v.setrotation(x and 511,x and 511,x and 511);
    v.render;
    v.project;
    viewpage(p);
  end;
  tmrStopSCRsync;
  v.done;
  initfade;
  while fadeout do waitsync;
end;

end.