{$G+,A+,R-,S-,Q-,O-}
unit Fall;

Interface

procedure PolyFall;

Implementation

uses VGAGIF, VGA, VGAPOLY, TEXTURE2, SOUND, CRT;

{$I CARROT.INC}

type
  poly = record
    bx,by,
    x1,y1,x2,y2,x3,y3,x4,y4,
    p1,t1,p2,t2,p3,t3,p4,t4 : integer;
    speed             : integer;
    ang               : integer;
  end;

var
  x, y, z : Integer;
  map     : Pointer;
  map2    : pointer;
  polys   : array [1..64] of poly;
  p       : pointer;
  num     : Integer;
  sint,
  cost    : array[0..255] of integer;
  xd1,
  yd1,
  xd2,
  yd2,
  xd3,
  yd3,
  xd4,
  yd4     : integer;

procedure addpoly(x1,y1,x2,y2,x3,y3,x4,y4:longint);
var
 tx,ty:integer;
begin
  if num = 128 then halt;
  inc (num);
  tx := abs(x2-x1) div 2;
  ty := abs(y4-y1) div 2;
  polys [num].bx := x1+tx;
  polys [num].by := y1+ty;
  polys [num].x1 := x1-x1-tx;
  polys [num].y1 := y1-y1-ty;
  polys [num].x2 := x2-x1-tx;
  polys [num].y2 := y2-y1-ty;
  polys [num].x3 := x3-x1-tx;
  polys [num].y3 := y3-y1-ty;
  polys [num].x4 := x4-x1-tx;
  polys [num].y4 := y4-y1-ty;
  polys [num].p1 := x1*256 div 320;
  polys [num].t1 := y1*256 div 200;
  polys [num].p2 := x2*256 div 320;
  polys [num].t2 := y2*256 div 200;
  polys [num].p3 := x3*256 div 320;
  polys [num].t3 := y3*256 div 200;
  polys [num].p4 := x4*256 div 320;
  polys [num].t4 := y4*256 div 200;
  polys [num].ang := 32;
  polys [num].speed := 3+random(5);    {3-7}
end;

procedure square (x1,y1,x2,y2,x3,y3,x4,y4,p1,t1,p2,t2,p3,t3,p4,t4:integer);
begin
  texturepolygon(x1,y1, x2,y2, x3,y3, polys[x].p1,polys[x].t1,
                                      polys[x].p2,polys[x].t2,
                                      polys[x].p3,polys[x].t3);
  texturepolygon(x1,y1, x3,y3, x4,y4, polys[x].p1,polys[x].t1,
                                      polys[x].p3,polys[x].t3,
                                      polys[x].p4,polys[x].t4);
end;

procedure scale320to256(var b:pointer); { THIS SUCKS ! }
type
 ar=array[0..0] of byte;
var
 x,y:longint;
 p1,
 p2:^ar;
begin
 p1:=ptr($A000,0);
 p2:=b;
 for x:=0 to 255 do
   for y:=0 to 255 do p2^[y*256+x]:=
     p1^[(y*200 div 256)*320+(x*320 div 256)];
end;

procedure PolyFall;
begin
  num := 0;
  getmem (map, 65535);
  getmem (p, 65535);
  scale320to256 (map);
  z := 0;
  for x := 0 to 7 do { MAKE GRID }
    for y := 0 to 4 do
      addpoly(x*40,y*40,(x+1)*40,y*40,(x+1)*40,(y+1)*40,x*40,(y+1)*40);

  vgapoly.page := seg(p^);
  vgapoly.textmap :=seg(map^);
  for x:=0 to 255 do begin
    sint[x]:=round(sin(x*2*pi/256)*127);
    cost[x]:=round(cos(x*2*pi/256)*127);
  end;

  maxx:=318;maxy:=198;
  for z := 1 to 80 do begin
   clearpage(p);
   for x := 1 to num do begin
      xd1 := (polys[x].x1*sint[(polys[x].ang)and 255] div 88)+polys[x].bx;
      xd2 := (polys[x].x2*cost[(polys[x].ang)and 255] div 88)+polys[x].bx;
      xd3 := (polys[x].x3*sint[(polys[x].ang)and 255] div 88)+polys[x].bx;
      xd4 := (polys[x].x4*cost[(polys[x].ang)and 255] div 88)+polys[x].bx;
      yd1 := (polys[x].y1*cost[(polys[x].ang)and 255] div 88)+polys[x].by;
      yd2 := (polys[x].y2*sint[(polys[x].ang)and 255] div 88)+polys[x].by;
      yd3 := (polys[x].y3*cost[(polys[x].ang)and 255] div 88)+polys[x].by;
      yd4 := (polys[x].y4*sint[(polys[x].ang)and 255] div 88)+polys[x].by;
      square(xd1,yd1,xd2,yd2,xd3,yd3,xd4,yd4,
             polys[x].p1,polys[x].t1,
             polys[x].p2,polys[x].t2,
             polys[x].p3,polys[x].t3,
             polys[x].p4,polys[x].t4);
     end;
     viewpage(p);
     for x:=1 to num do begin
       inc(polys[x].by,polys[x].speed);
       polys[x].ang := (polys[x].ang+4) and 255;
     end;
  end;
  freemem (map, 65535);
  freemem (p, 65535);
end;

end.
