// mighty.engine version 0.10
// camera class

#include "engine.h"

//////////////////////////////////////////////////////////////////////////////

Camera::Camera ()
{
}

Camera::~Camera ()
{
  delete target;
  delete position;
}

Camera::Camera (float srcX, float srcY, float srcZ,
                float dstX, float dstY, float dstZ)
{
  position = new Point (srcX, srcY, srcZ);
  target = new Point (dstX, dstY, dstZ);
  Update ();
}

void Camera::SetTo (float srcX, float srcY, float srcZ,
                    float dstX, float dstY, float dstZ)
{
  position->SetCoords (srcX, srcY, srcZ);
  target->SetCoords (dstX, dstY, dstZ);
  Update ();
}

void Camera::Update ()
{
  float magnitude;

  SubVec (target, position);
  tPoint->Normalise ();

  Nx = tPoint->x3d;
  Ny = tPoint->y3d;
  Nz = tPoint->z3d;
  Vx = -Ny*Nx;
  Vy = 1.0-(Ny*Ny);
  Vz = -Ny*Nz;
  magnitude = SQRT ((Vx*Vx)+(Vy*Vy)+(Vz*Vz));
  Vx /= magnitude;
  Vy /= magnitude;
  Vz /= magnitude;
  Ux = (Nz*Vy) - (Ny*Vz);
  Uy = (Nx*Vz) - (Nz*Vx);
  Uz = (Ny*Vx) - (Nx*Vy);
}
