// mighty.engine version 0.10
// point class

#include "engine.h"

//////////////////////////////////////////////////////////////////////////////

Point::Point ()
{
}

Point::~Point ()
{
}

Point::Point (float x, float y, float z)
{
  SetCoords (x, y, z);
}

void Point::Save ()
{
  localX = x3d;
  localY = y3d;
  localZ = z3d;
}

void Point::SetCoords (float x, float y, float z)
{
  x3d = localX = x;
  y3d = localY = y;
  z3d = localZ = z;
  ZeroNormal();
}

void Point::SetTexCoords (float U, float V)
{
  U = fabs (U);
  V = fabs (V);
  if (U > 1.0) U = (float)(U - (int)U);
  if (V > 1.0) V = (float)(V - (int)V);
  u = int (U*16384.0);
  v = int (V*16384.0);
}

void Point::Normalise()
{
  float magnitude;

  magnitude = SQRT ((x3d*x3d)+(y3d*y3d)+(z3d*z3d));
  x3d /= magnitude;
  y3d /= magnitude;
  z3d /= magnitude;
  magnitude = SQRT ((localX*localX)+(localY*localY)+(localZ*localZ));
  localX /= magnitude;
  localY /= magnitude;
  localZ /= magnitude;
}

void Point::ZeroNormal ()
{
  normalX = 0.0;
  normalY = 0.0;
  normalZ = 0.0;
  numNormals = 0;
}

void Point::AddNormal (float x, float y, float z)
{
  normalX += x;
  normalY += y;
  normalZ += z;
  numNormals++;
}

void Point::AverageNormal ()
{
  float mag;

  if (numNormals>0) {
    normalX /= numNormals;
    normalY /= numNormals;
    normalZ /= numNormals;
    mag = SQRT ((normalX*normalX)+(normalY*normalY)+(normalZ*normalZ));
    normalX /= mag;
    normalY /= mag;
    normalZ /= mag;
  }
}
