Unit Ansi;

Interface

Uses
  Dos;

type
  PBuffer = ^TBuffer;
  TBuffer = Array [1..200, 1..80] of record ch:char; at:byte end;

var
  lines : Integer;

procedure loadansi(s:string; p:pointer);

Implementation

Type
  States              = (Waiting, Bracket, Get_Args, Get_Param, Eat_Semi,
                         Get_String, In_Param, Get_Music);
Const
  St                  : String = '';
  ParamArr            : Array[1..10] Of Word = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
  Params              : Word = 0; { number of parameters }
  NextState           : States = Waiting; { next state for the parser }
  Reverse             : Boolean = False; { true if text attributes are reversed }

Var
  Quote               : Char;
  SavedX, SavedY      : Word;
  aWhereX, aWhereY    : Integer;
  aTextattr           : Byte;
  buffer              : PBuffer;
  stop                : boolean;

Procedure aGotoxy (x, y : Integer);
Begin
  aWherex := x;
  aWherey := y;
End;

  Procedure WriteChar(Ch : Char);
  Begin
    if stop then exit;
    if awherey > 200 then exit;
    Case Ch Of
     #$1A: stop := true;
      #10: awherex:=1;
      #13: inc(awherey);
      #8 : If (aWhereX > 1) then begin
             buffer^[awherey,awherex].ch := #32;
             if awherex>1 then dec(awherex);
           end;
      #9 : If (aWhereX < 71) then
           Repeat
             aGotoXy(aWhereX + 1, aWherey);
           Until (aWhereX Mod 8 = 1);
      Else begin
        buffer^[awherey,awherex].ch := ch;
        buffer^[awherey,awherex].at := atextattr;
        if awherex<80 then inc(awherex) else begin
          awherex:=1;
          inc(awherey);
        end;
      End;
    End;
    if lines < awherey then lines := awherey;
  End ;

  Procedure AnsiWrite(Ch : Char);

  Var
    i                   : Word;

  Label Command;

  Begin
    If Ch = #27 Then
    Begin
      NextState := Bracket;
      Exit;
    End;
    Case NextState Of
      Waiting : WriteChar(Ch);
      Bracket : Begin
          If Ch <> '[' Then
          Begin
            NextState := Waiting;
            WriteChar (ch);
            Exit;
          End;
          St := '';
          Params := 1;
          FillChar (ParamArr, 10, 0);
          NextState := Get_Args;
        End;
      Get_Args, Get_Param, Eat_Semi :
        Begin
          If (NextState = Get_Args) And ((Ch = '=') Or (Ch = '?')) Then
          Begin
            NextState := Get_Param;
            Exit;
          End;
          If (NextState = Eat_Semi) And (Ch = ';') Then
          Begin
            If Params < 10 Then Inc(Params);
            NextState := Get_Param;
            Exit;
          End;
          Case Ch Of
            '0'..'9' :
              Begin
                ParamArr[Params] := Ord(Ch) - Ord('0');
                NextState := In_Param;
              End;
            ';' :
              Begin
                If Params < 10 Then Inc(Params);
                NextState := Get_Param;
              End;
            '"', '''' :
              Begin
                Quote := Ch;
                St := St + Ch;
                NextState := Get_String;
              End;
            Else
              GoTo Command;
          End {Case Ch} ;
        End;
      Get_String :
        Begin
          St := St + Ch;
          If Ch <> Quote
          Then NextState := Get_String
          Else NextState := Eat_Semi;
        End;
      In_Param :                  { last char was a digit }
        Begin
          { looking for more digits, a semicolon, or a command char }
          Case Ch Of
            '0'..'9' :
              Begin
                ParamArr[Params] := ParamArr[Params] * 10 + Ord(Ch) - Ord('0');
                NextState := In_Param;
                Exit;
              End;
            ';' :
              Begin
                If Params < 10 Then Inc(Params);
                NextState := Eat_Semi;
                Exit;
              End;
          End {Case Ch} ;
Command:
          NextState := Waiting;
          Case Ch Of
            { Note: the order of commands is optimized for execution speed }
            'm' :                 {sgr}
              Begin
                For i := 1 To Params Do
                Begin
                  If Reverse Then aTextAttr := aTextAttr Shr 4 + aTextAttr Shl 4;
                  Case ParamArr[i] Of
                    0 :
                      Begin
                        Reverse := False;
                        aTextAttr := 7;
                      End;
                    1 : aTextAttr := aTextAttr And $FF Or $08;
                    2 : aTextAttr := aTextAttr And $F7 Or $00;
                    4 : aTextAttr := aTextAttr And $F8 Or $01;
                    5 : aTextAttr := aTextAttr Or $80;
                    7 : If Not Reverse Then
                        Begin
                      {
                      TextAttr := TextAttr shr 4 + TextAttr shl 4;
                      }
                          Reverse := True;
                        End;
                    22 : aTextAttr := aTextAttr And $F7 Or $00;
                    24 : aTextAttr := aTextAttr And $F8 Or $04;
                    25 : aTextAttr := aTextAttr And $7F Or $00;
                    27 : If Reverse Then
                         Begin
                           Reverse := False;
                      {
                      TextAttr := TextAttr shr 4 + TextAttr shl 4;
                      }
                         End;
                    30 : aTextAttr := aTextAttr And $F8 Or $00;
                    31 : aTextAttr := aTextAttr And $F8 Or $04;
                    32 : aTextAttr := aTextAttr And $F8 Or $02;
                    33 : aTextAttr := aTextAttr And $F8 Or $06;
                    34 : aTextAttr := aTextAttr And $F8 Or $01;
                    35 : aTextAttr := aTextAttr And $F8 Or $05;
                    36 : aTextAttr := aTextAttr And $F8 Or $03;
                    37 : aTextAttr := aTextAttr And $F8 Or $07;
                    40 : aTextAttr := aTextAttr And $8F Or $00;
                    41 : aTextAttr := aTextAttr And $8F Or $40;
                    42 : aTextAttr := aTextAttr And $8F Or $20;
                    43 : aTextAttr := aTextAttr And $8F Or $60;
                    44 : aTextAttr := aTextAttr And $8F Or $10;
                    45 : aTextAttr := aTextAttr And $8F Or $50;
                    46 : aTextAttr := aTextAttr And $8F Or $30;
                    47 : aTextAttr := aTextAttr And $8F Or $70;
                  End {Case} ;
                  { fixup for reverse }
                  If Reverse Then aTextAttr := aTextAttr Shr 4 + aTextAttr Shl 4;
                End;
              End;
            'A' :                 {cuu}
              Begin
                If ParamArr[1] = 0 Then ParamArr[1] := 1;
                If (aWherey - ParamArr[1] >= 1)
                Then aGotoXy(aWhereX, aWherey - ParamArr[1])
                Else aGotoXy(aWhereX, 409);
              End;
            'J' : NextState := Waiting;
            'B' :                 {cud}
              Begin
                If ParamArr[1] = 0 Then ParamArr[1] := 1;
                If (aWherey + ParamArr[1] <= 409)
                Then aGotoXy(aWhereX, aWherey + ParamArr[1])
                Else aGotoXy(aWhereX, 1);
              End;
            'C' :                 {cuf}
              Begin
                If ParamArr[1] = 0 Then ParamArr[1] := 1;
                If aWhereX + ParamArr[1] <= 80
                Then aGotoXy(aWhereX + ParamArr[1], aWherey)
                Else aGotoXy(80, aWherey);
              End;
            'D' :                 {cub}
              Begin
                If ParamArr[1] = 0 Then ParamArr[1] := 1;
                If (aWhereX - ParamArr[1] >= 1)
                Then aGotoXy(aWhereX - ParamArr[1], aWherey)
                Else aGotoXy(1, aWherey);
              End;
            'H', 'f' :            {cup,hvp}
              Begin
                If ParamArr[1] = 0 Then ParamArr[1] := 1;
                If ParamArr[2] = 0 Then ParamArr[2] := 1;
                aGotoXy(ParamArr[2], ParamArr[1]);
              End;
            'P' :                 {dc }
              Begin
              End;
            '@' :                 {ic}
              Begin
                { insert blank chars }
              End;
            'h' : NextState := Waiting;
            's' :                 {scp}
              Begin
                SavedX := aWhereX;
                SavedY := aWherey;
              End;
            'u' : {rcp} aGotoXy(SavedX, SavedY);
            Else writechar(ch);
          End {Case Ch} ;
        End;
    End {Case NextState} ;
  End {AnsiWrite} ;

procedure loadansi(s:string; p:pointer);
var
   f:file;
 buf:array[1..8192] of char;
   x,w:word;
begin
  fillchar(p^,32767,0);
  aWhereX := 1;
  aWhereY := 1;
  atextattr := 7;
  buffer:=p;
  assign(f,s);
  reset(f,1);
  w:=8192;
  lines := 0;
  stop := false;
  while w=8192 do begin
    blockread(f,buf,8192,w);
    for x:=1 to w do ansiwrite(buf[x]);
  end;
  close(f);
end;

End.
