;
; quick and dirty vector engine (done in 2 days)
;
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; code (user routines)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                       
vec_render:            
;-----------------------------------------------------------------------------
; input:  rx,ry,rz,lx,ly,lz
; output: none         
;-----------------------------------------------------------------------------
  mov  ax, ds          
  mov  es, ax          
  mov  w rlight[0], 0
  mov  w rlight[2], 0
  mov  w rlight[4], -512
  mov  di, o rlight    
  call single_rotate
  call prepare_shading 
  mov  si, o vrotate
  mov  bp, numPoints
  call transform_matrix
  call prepare_sort
  mov  bp, numFaces
  call polygon_sort
  ret             
               
vec_project:     
;-----------------------------------------------------------------------------
; input:  none   
; output: none   
;-----------------------------------------------------------------------------
  mov  cx, numFaces
  xor  bp, bp
przloop:              
    push  cx         
    push  bp         
    mov   bx, plist[bp]
    mov   bp, bx    
    movzx bx, b vector_faces[bp]
    mov   cx, bx       
    add   cx, cx       
    shl   bx, 2        
    add   bx, cx       
    mov   x, bx        
    movzx bx, b vector_faces[bp+1]
    mov   cx, bx               
    add   cx, cx               
    shl   bx, 2                
    add   bx, cx               
    mov   y, bx   
    movzx bx, b vector_faces[bp+2]
    mov   cx, bx               
    add   cx, cx               
    shl   bx, 2                
    add   bx, cx  
    mov   z, bx   
    mov   bx, x   
    mov   ax, w vrotated[bx]
    add   ax, 30    
    mov   x1, ax  
    mov   ax, w vrotated[bx+2]
    add   ax, 30  
    mov   y1, ax  
    mov   bx, y   
    mov   ax, w vrotated[bx]
    add   ax, 30    
    mov   x2, ax   
    mov   ax, w vrotated[bx+2]
    add   ax, 30  
    mov   y2, ax  
    mov   bx, z   
    mov   ax, w vrotated[bx]
    add   ax, 30    
    mov   x3, ax  
    mov   ax, w vrotated[bx+2]
    add   ax, 30  
    mov   y3, ax             
    mov   c1, 0   
    mov   c2, 0   
    mov   c3, 0   
    call  gouraud_triangle
    pop   bp       
    pop   cx      
    add   bp, 2    
    dec   cx                     
  jnz  przloop    
  mov  cx, numFaces
  xor  bp, bp     
prloop:              
    push  cx         
    push  bp         
    mov   bx, plist[bp]
    mov   bp, bx    
    movzx bx, b vector_faces[bp]
    movzx ax, b dlist[bx]
    mov   c1, ax     
    mov   cx, bx       
    add   cx, cx       
    shl   bx, 2        
    add   bx, cx       
    mov   x, bx        
    movzx bx, b vector_faces[bp+1]
    movzx ax, b dlist[bx]
    mov   c2, ax  
    mov   cx, bx               
    add   cx, cx               
    shl   bx, 2                
    add   bx, cx               
    mov   y, bx   
    movzx bx, b vector_faces[bp+2]
    movzx ax, b dlist[bx]
    mov   c3, ax    
    mov   cx, bx               
    add   cx, cx               
    shl   bx, 2                
    add   bx, cx  
    mov   z, bx   
    mov   bx, x   
    mov   ax, w vrotated[bx]
    mov   x1, ax  
    mov   ax, w vrotated[bx+2]
    mov   y1, ax  
    mov   bx, y   
    mov   ax, w vrotated[bx]
    mov   x2, ax   
    mov   ax, w vrotated[bx+2]
    mov   y2, ax  
    mov   bx, z   
    mov   ax, w vrotated[bx]
    mov   x3, ax                 
    mov   ax, w vrotated[bx+2]
    mov   y3, ax             
    call  gouraud_triangle
    pop   bp       
    pop   cx      
    add   bp, 2    
    dec   cx                     
  jnz  prloop                    
  ret  
             
vec_morph:   
;-----------------------------------------------------------------------------
; input:  si=source, bx=dest
; output: none         
;-----------------------------------------------------------------------------
  mov  bp, numPoints*3
  mov  di, offset vrotate
morphloop:               ; NewX = (X2 - X1) * Stage / Stages + X1
    mov  ax, ds:[bx]  
    sub  ax, ds:[si]  
    mul  stage
    sar  ax, 5           ; 32 stages
    add  ax, ds:[si]
    mov  ds:[di], ax
    add  di, 2      
    add  si, 2      
    add  bx, 2      
    dec  bp   
  jnz  morphloop    
  ret               

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; code (internal routines)      
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                            
gouraud_triangle: 
;-----------------------------------------------------------------------------
  cld
  mov   ax, x1               
  mov   bx, y1      
  mov   cx, c1
  mov   dx, x2              
  mov   si, y2  
  mov   di, c2  
  cmp   bx, si
  jle   pok1    
  xchg  ax, dx   
  xchg  bx, si  
  xchg  cx, di
pok1:                                          
  cmp   bx, y3
  jle   pok2
  xchg  ax, [x3]   
  xchg  bx, [y3]
  xchg  cx, [c3]
pok2:                  
  cmp   si, y3
  jl    pok3
  xchg  dx, x3      
  xchg  si, y3
  xchg  di, c3
pok3:           
  mov   x1, ax 
  mov   y1, bx
  mov   c1, cx                                  
  mov   x2, dx                                  
  mov   y2, si                                  
  mov   c2, di                                  
  movsx eax, x1
  sal   eax, 16
  mov   xx1, eax
  movsx eax, x2    
  sal   eax, 16
  mov   xx2, eax
  movsx eax, x3        
  sal   eax, 16
  mov   xx3, eax
  movsx eax, c1     
  sal   eax, 16
  mov   cc1, eax
  movsx eax, c2 
  sal   eax, 16
  mov   cc2, eax
  movsx eax, c3
  sal   eax, 16  
  mov   cc3, eax
  mov   ax, y1
  cmp   ax, y2  
  jne   pnonflat1
  xor   eax, eax
  mov   dx1, eax   
  mov   dc1, eax
  jmp   pok6
pnonflat1:             
  movsx ebx, y2
  movsx ecx, y1
  sub   ebx, ecx    
  mov   eax, xx2
  sub   eax, xx1
  cdq           
  idiv  ebx    
  mov   dx1, eax
  mov   eax, cc2
  sub   eax, cc1 
  cdq
  idiv  ebx  
  mov   dc1, eax
pok6:           
  mov   ax, y2
  cmp   ax, y3     
  jne   pnonflat2
  xor   eax, eax
  mov   dx2, eax       
  mov   dc2, eax
  jmp   pok9
pnonflat2:          
  movsx ebx, y3
  movsx ecx, y2
  sub   ebx, ecx
  mov   eax, xx3
  sub   eax, xx2
  cdq          
  idiv  ebx      
  mov   dx2, eax
  mov   eax, cc3
  sub   eax, cc2
  cdq         
  idiv  ebx     
  mov   dc2, eax   
pok9:          
  mov   ax, y1
  cmp   ax, y3         
  jne   pnonflat3
  xor   eax, eax
  mov   dx3, eax    
  mov   dc3, eax
  jmp   pok12
pnonflat3:    
  movsx ebx, y3
  movsx ecx, y1
  sub   ebx, ecx
  mov   eax, xx3 
  sub   eax, xx1
  cdq        
  idiv  ebx
  mov   dx3, eax
  mov   eax, cc3
  sub   eax, cc1   
  cdq          
  idiv  ebx
  mov   dc3, eax       
pok12:
  mov   eax, xx1
  mov   cx1, eax    
  mov   eax, cc1
  mov   pc1, eax
  mov   ax, y1
  cmp   ax, y2 
  jne   pnonflat4
  mov   eax, xx2
  mov   cx2, eax 
  mov   eax, cc2
  mov   pc2, eax
  jmp   pok13
pnonflat4:    
  mov   eax, xx1
  mov   cx2, eax   
  mov   eax, cc1
  mov   pc2, eax
pok13:                 
  mov   ax, y1
  mov   y, ax
  mov   es, virtseg 
  cmp   ax, 0
  jge   pok132
  mov   ax, 0 
pok132:        
  mov   di, ax
  shl   ax, 8  
  shl   di, 6    
  add   di, ax
plineloop:   
    mov  ax, y
    cmp  ax, 0
    jl   pnextline
    cmp  ax, 199   
    jg   pexit 
    cmp  ax, y3 
    jg   pexit         
    mov  eax, cx1
    cmp  eax, cx2
    jle  pok14      
    mov  mx2, eax
    mov  eax, cx2
    mov  mx1, eax
    mov  eax, pc1
    mov  mc2, eax
    mov  eax, pc2
    mov  mc1, eax
    jmp  pok15
pok14:       
    mov  mx1, eax
    mov  eax, cx2
    mov  mx2, eax
    mov  eax, pc1  
    mov  mc1, eax
    mov  eax, pc2
    mov  mc2, eax      
pok15:
    xor  ecx, ecx
    sar  mx1, 16           
    adc  mx1, ecx
    sar  mx2, 16
    adc  mx2, ecx
    mov  eax, mx1
    cmp  eax, mx2
    jne  pnonflat5
    xor  eax, eax
    mov  dcc1, eax
    jmp  pok17
pnonflat5:
    mov  eax, mc2
    sub  eax, mc1
    mov  ebx, mx2  
    sub  ebx, mx1
    cdq
    idiv ebx           
    mov  dcc1, eax
pok17:
    mov  si, di     
    mov  ax, w mx1
    cmp  ax, 0 
    jge  pok172
    mov  ax, 0 
pok172:     
    add  di, ax
ploop:           
      mov  ax, w mx1
      cmp  ax, 0
      jl   pnextpixel
      cmp  ax, 319
      jg   pendline
      cmp  ax, w mx2
      jg   pendline
      mov  eax, mc1
      xor  ebx, ebx    
      sar  eax, 16
      adc  eax, ebx
      mov  es:[di], al
      inc  di
pnextpixel:
      inc  w mx1
      mov  eax, dcc1
      add  mc1, eax
    jmp  ploop 
pendline:        
    mov  di, si
    add  di, 320
pnextline:
    mov  eax, dx3
    add  cx1, eax
    mov  eax, dc3  
    add  pc1, eax
    mov  ax, y
    cmp  ax, y2        
    jl   ptop
    mov  eax, dx2
    add  cx2, eax   
    mov  eax, dc2
    add  pc2, eax
    jmp  pok18
ptop:          
    mov  eax, dx1
    add  cx2, eax
    mov  eax, dc1
    add  pc2, eax
pok18:       
    inc  y
  jmp  plineloop
pexit:       
  ret              
               
prepare_matrix: ; in=rx,ry,rz
;-----------------------------------------------------------------------------
  mov   bx, rx
  add   bx, bx
  mov   ax, sintable[bx]
  mov   rsx, ax 
  mov   ax, costable[bx]
  mov   rcx, ax
  mov   bx, ry 
  add   bx, bx
  mov   ax, sintable[bx]
  mov   rsy, ax  
  mov   ax, costable[bx]
  mov   rcy, ax
  mov   bx, rz
  add   bx, bx
  mov   ax, sintable[bx]
  mov   rsz, ax    
  mov   ax, costable[bx]
  mov   rcz, ax
  movsx eax, rsx       
  movsx ebx, rsz
  imul  ebx  
  sar   eax, 7      
  mov   sxsz, ax
  movsx eax, rcz
  movsx ebx, rsx
  imul  ebx    
  sar   eax, 7
  mov   czsx, ax
  movsx eax, rcz 
  movsx ebx, rcy
  imul  ebx  
  mov   ecx, eax
  movsx eax, sxsz
  movsx ebx, rsy
  imul  ebx        
  add   eax, ecx
  sar   eax, 7
  mov   matrix[2*0], ax
  movsx eax, czsx
  movsx ebx, rsy
  imul  ebx         
  mov   ecx, eax
  movsx eax, rcy
  movsx ebx, rsz
  imul  ebx    
  sub   ecx, eax
  sar   ecx, 7 
  mov   matrix[2*1], cx
  movsx eax, rcx
  movsx ebx, rsy
  imul  ebx      
  sar   eax, 7   
  mov   matrix[2*2], ax
  movsx eax, rsz     
  movsx ebx, rcx
  imul  ebx   
  sar   eax, 7         
  mov   matrix[2*3], ax
  movsx eax, rcz
  movsx ebx, rcx    
  imul  ebx  
  sar   eax, 7
  mov   matrix[2*4], ax
  mov   ax, rsx 
  neg   ax   
  mov   matrix[2*5], ax
  movsx eax, sxsz
  movsx ebx, rcy
  imul  ebx  
  mov   ecx, eax
  movsx eax, rsy
  movsx ebx, rcz
  imul  ebx          
  sub   ecx, eax
  sar   ecx, 7
  mov   matrix[2*6], cx
  movsx eax, rsz
  movsx ebx, rsy
  imul  ebx         
  mov   ecx, eax
  movsx eax, czsx
  movsx ebx, rcy
  imul  ebx    
  add   eax, ecx
  sar   eax, 7 
  mov   matrix[2*7], ax
  movsx eax, rcx
  movsx ebx, rcy
  imul  ebx  
  sar   eax, 7
  mov   matrix[2*8], ax
  ret                
               
transform_matrix: ; si=source, bp=size;
;-----------------------------------------------------------------------------
  call   prepare_matrix
  mov    di, o vrotated
transform_loop:     
    push  bp 
    mov   ax, ds:[si]
    imul  matrix[2*0]
    mov   cx, ax
    mov   ax, ds:[si+2]
    imul  matrix[2*1]
    mov   bp, ax 
    mov   ax, ds:[si+4]
    imul  matrix[2*2]
    add   ax, bp
    add   ax, cx
    sar   ax, 7
    mov   ds:[di], ax
    mov   ax, ds:[si]
    imul  matrix[2*3] 
    mov   cx, ax       
    mov   ax, ds:[si+2]
    imul  matrix[2*4]
    mov   bp, ax    
    mov   ax, ds:[si+4]
    imul  matrix[2*5]
    add   ax, bp 
    add   ax, cx 
    sar   ax, 7  
    mov   ds:[di+2], ax
    mov   ax, ds:[si]
    imul  matrix[2*6]
    mov   cx, ax
    mov   ax, ds:[si+2]
    imul  matrix[2*7]
    mov   bp, ax
    mov   ax, ds:[si+4]
    imul  matrix[2*8]
    add   ax, bp      
    add   ax, cx       
    sar   ax, 7
    mov   ds:[di+4], ax
    xor   ecx, ecx  
    movsx eax, w ds:[di]
    movsx ecx, lx
    add   eax, ecx
    sal   eax, 8
    movsx ebx, w ds:[di+4]
    movsx ecx, lz
    add   ebx, ecx
    cdq           
    idiv  ebx     
    add   ax, 160 
    mov   ds:[di], ax
    xor   ecx, ecx
    movsx eax, w ds:[di+2]
    movsx ecx, ly      
    add   eax, ecx
    sal   eax, 8   
    movsx ebx, w ds:[di+4]
    movsx ecx, lz
    add   ebx, ecx  
    cdq            
    idiv  ebx      
    mov   cx, 100  
    sub   cx, ax      
    mov   ds:[di+2], cx
    add   di, 6
    add   si, 6  
    pop   bp  
    dec   bp    
  jnz   transform_loop
  ret     
          
single_rotate: ; in/out=di
;-----------------------------------------------------------------------------
  call  prepare_matrix
  mov   si, o light
  movsx eax, w ds:[di]
  movsx ebx, matrix[2*0]
  imul  ebx           
  mov   ecx, eax      
  movsx eax, w ds:[di+2]
  movsx ebx, matrix[2*1]
  imul  ebx    
  mov   ebp, eax
  movsx eax, w ds:[di+4]
  movsx ebx, matrix[2*2]
  imul  ebx   
  add   eax, ebp
  add   eax, ecx
  sar   eax, 7
  mov   ds:[si], ax
  movsx eax, w ds:[di] 
  movsx ebx, matrix[2*3]
  imul  ebx        
  mov   ecx, eax   
  movsx eax, w ds:[di+2]
  movsx ebx, matrix[2*4]
  imul  ebx         
  mov   ebp, eax   
  movsx eax, w ds:[di+4]
  movsx ebx, matrix[2*5]
  imul  ebx        
  add   eax, ebp   
  add   eax, ecx   
  sar   eax, 7     
  mov   ds:[si+2], ax
  movsx eax, w ds:[di]
  movsx ebx, matrix[2*6]
  imul  ebx        
  mov   ecx, eax   
  movsx eax, w ds:[di+2]
  movsx ebx, matrix[2*7]
  imul  ebx        
  mov   ebp, eax   
  movsx eax, w ds:[di+4]
  movsx ebx, matrix[2*8]
  imul  ebx         
  add   eax, ebp   
  add   eax, ecx   
  sar   eax, 7     
  mov   ds:[si+4], ax
  ret              
                   
prepare_shading:   
;-----------------------------------------------------------------------------
  mov   cx, numPoints
  mov   di, o dlist
  xor   bp, bp     
pgloop:            
    push  cx       
    push  bp       
    push  di       
    mov   di, o vector_normals
    add   di, bp   
    mov   si, o light
    call  dot_product
    pop   di       
    cmp   ax, 0    
    jle   pg3      
pg1:shl   ax, intensity
    sar   ax, 9    
pg2:cmp   al, 63   
    jbe   pg7      
    mov   al, 63   
    jmp   pg7      
pg3:mov   al, 0    
pg7:add   al, 127
    mov   b ds:[di], al
    inc   di       
    pop   bp       
    add   bp, 6   
    pop   cx       
    dec   cx    
  jnz   pgloop  
  ret               
                
prepare_sort:   
;-----------------------------------------------------------------------------
  mov  cx, numFaces
  mov  si, o plist
  xor  bx, bx
psiloop:         
    mov  ds:[si], bx
    add  bx, 3
    add  si, 2
    dec  cx     
  jnz  psiloop
  mov  cx, numFaces
  mov  bp, o vector_faces
  mov  di, o zlist
psaloop:    
    push  cx
    movzx bx, b ds:[bp]
    mov   cx, bx    
    add   cx, cx
    shl   bx, 2
    add   bx, cx
    mov   dx, w vrotated[bx+4]
    movzx bx, b ds:[bp+1]
    mov   cx, bx
    add   cx, cx
    shl   bx, 2
    add   bx, cx
    add   dx, w vrotated[bx+4]
    movzx bx, b ds:[bp+2]
    mov   cx, bx
    add   cx, cx   
    shl   bx, 2
    add   bx, cx
    add   dx, w vrotated[bx+4]
    mov   ax, 32767
    sub   ax, dx
    mov   ds:[di], ax
    add   di, 2
    add   bp, 3
    pop   cx  
    dec   cx   
  jnz   psaloop
  ret         
              
dot_product: ; in=di,si out=ax
;-----------------------------------------------------------------------------
  movsx eax, w ds:[di]
  movsx ebx, w ds:[si]
  imul  ebx      
  mov   ecx, eax
  movsx eax, w ds:[di+2]
  movsx ebx, w ds:[si+2]
  imul  ebx             
  add   ecx, eax        
  movsx eax, w ds:[di+4]
  movsx ebx, w ds:[si+4]
  imul  ebx            
  add   ecx, eax
  sar   ecx, 9
  mov   ax, cx
  ret                  
                       
polygon_sort: ; non-recursive quick sort
;-----------------------------------------------------------------------------
  mov  l, 0      
  mov  r, numFaces-1
  xor  ax, ax
  push ax
  push ax
  push r 
  push l  
qsortloop:
    mov  di, o zlist
    mov  tmpdi, di
    xor  si, si
    mov  bx, di
    pop  ax
    mov  tmpl, ax
    mov  si, ax
    shl  ax, 1
    add  di, ax
    pop  ax
    mov  tmpr, ax
    and  ax, ax
    jz   sortend 
    add  si, ax
    shl  ax, 1
    add  bx, ax
    and  si, 0fffeh
    add  si, tmpdi
    mov  ax, ds:[si]
qsortloop1:      
      mov  cx, ds:[di]
      cmp  ax, cx
      jna  qsortloop2
      add  di, 2
    jmp  qsortLoop1
qsortloop2:   
      mov  cx, ds:[bx]
      cmp  cx, ax
      jna  qcheck
      sub  bx, 2
    jmp  qsortloop2
qcheck:          
    cmp  di, bx
    jg   qcont1
    mov  cx, ds:[di]
    mov  dx, ds:[bx]
    mov  ds:[di], dx
    mov  ds:[bx], cx
    mov  cx, ds:[di+1024]
    mov  dx, ds:[bx+1024]
    mov  ds:[di+1024], dx 
    mov  ds:[bx+1024], cx
    add  di, 2
    sub  bx, 2
    cmp  di, bx
    jng  qsortLoop1
qcont1:    
    sub  di, tmpdi
    sar  di, 1    
    sub  bx, tmpdi
    sar  bx, 1    
    cmp  di, tmpr 
    jge  qcont2
    push tmpr         
    push di
qcont2:    
    cmp  tmpl, bx
    jge  qsortloop
    push bx
    push tmpl
  jmp  qsortLoop
sortend:   
  ret      
  