;
; general routines
;
  
system_init:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  mov    ax, data 
  mov    ds, ax   
  mov    escape, 0
  mov    ax, 1A00h
  int    10h
  cmp    al, 1Ah
  je     vga_ok
  mov    ah, 9
  mov    dx, o vga_error
  int    21h
  mov    ax, 4c00h
  int    21h
vga_ok:
  mov    ah, 48h
  mov    bx, 4096
  int    21h     
  jc     mem_error
  mov    dataseg1, ax
  mov    ah, 48h
  mov    bx, 4096
  int    21h     
  jc     mem_error
  mov    dataseg2, ax
  mov    ah, 48h
  mov    bx, 4096
  int    21h     
  jc     mem_error
  mov    dataseg3, ax
  mov    ah, 48h 
  mov    bx, 4096
  int    21h     
  jc     mem_error           
  mov    dataseg4, ax        
  mov    ah, 48h             
  mov    bx, 4096            
  int    21h                 
  jc     mem_error           
  mov    virtseg, ax         
  jmp    mem_ok              
mem_error:                   
  mov    ah, 9               
  mov    dx, o memory_error  
  int    21h                 
  mov    ax, 4c00h           
  int    21h                 
mem_ok:                      
  mov    ax, 4300h           
  int    2fh                 
  cmp    al, 80h             
  jne    xms_notok
  mov    ax, 4310h
  int    2fh                 
  mov    w [XMSaddr], bx
  mov    w [XMSaddr+2], es
  mov    ah, 8               
  call   d XMSaddr           
  or     ax, ax              
  jnz    xmsmem_ok           
  xor    dx, dx              
xmsmem_ok:                   
  cmp    dx, 512 
  jae    xms_ok  
xms_notok:                   
  mov    ah, 9               
  mov    dx, offset xms_error
  int    21h        
  mov    ax, 4c00h
  int    21h     
xms_ok:          
  mov    ah, 9       
  mov    dx, 64      
  call   XMSaddr     
  or     ax, ax   
  jz     xms_notok
  mov    xhandle1, dx
  mov    ah, 9       
  mov    dx, 64      
  call   XMSaddr     
  or     ax, ax   
  jz     xms_notok
  mov    xhandle2, dx
  mov    ah, 9       
  mov    dx, 64      
  call   XMSaddr     
  or     ax, ax   
  jz     xms_notok
  mov    xhandle3, dx
  mov    ah, 9       
  mov    dx, 64      
  call   XMSaddr     
  or     ax, ax   
  jz     xms_notok
  mov    xhandle4, dx
  mov    ah, 9       
  mov    dx, 64      
  call   XMSaddr     
  or     ax, ax   
  jz     xms_notok
  mov    xhandle5, dx
  mov    ah, 9       
  mov    dx, 64      
  call   XMSaddr     
  or     ax, ax   
  jz     xms_notok
  mov    xhandle6, dx
  mov    ah, 9   
  mov    dx, 64      
  call   XMSaddr     
  or     ax, ax   
  jz     xms_notok 
  mov    xhandle7, dx
  call   init_sound
  mov    ax, 3509h
  int    21h     
  mov    w keyboard_old, es
  mov    w keyboard_old[2], bx
  mov    ax, 2509h
  mov    dx, o keyboard_isr
  push   ds   
  push   cs   
  pop    ds   
  int    21h
  pop    ds   
  mov    ah, 9
  mov    dx, o loading_text
  int    21h      
  mov    frame_count, 0
  mov    user_routine, o null_routine
  ret              
               
system_shutdown:             
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  mov  ss, StackSegment
  mov  sp, StackPointer
  mov  escape, 1
  mov  ax, data
  mov  ds, ax
  call stop_sound
  mov  ah, 0ah
  mov  dx, xhandle1
  call XMSaddr
  mov  ah, 0ah
  mov  dx, xhandle2
  call XMSaddr     
  mov  ah, 0ah     
  mov  dx, xhandle3
  call XMSaddr    
  mov  ah, 0ah     
  mov  dx, xhandle4
  call XMSaddr     
  mov  ah, 0ah     
  mov  dx, xhandle5
  call XMSaddr     
  mov  ah, 0ah     
  mov  dx, xhandle6
  call XMSaddr     
  mov  ah, 0ah     
  mov  dx, xhandle7
  call XMSaddr     
  mov  ax, 03h     
  int  10h         
  push ds          
  mov  ax, w keyboard_old
  mov  dx, w keyboard_old[2]
  mov  ds, ax     
  mov  ax, 2509h    
  int  21h   
  pop  ds
  mov  ah, 9 
  mov  dx, o exit_text       
  int  21h    
  mov  ax, 4c00h
  int  21h
     
xms_get:                  
;-----------------------------------------------------------------------------
; input:  bx = handle, es = target segment
; output: none
;-----------------------------------------------------------------------------
  mov  ah, 0bh            
  mov  si, o xmsstruct    
  mov  xmsLength, 65536
  mov  xmsSourceHandle, bx   
  mov  xmsSourceOffset, 0    
  mov  xmsDestHandle, 0      
  mov  w [xmsDestOffset], 0
  mov  w [xmsDestOffset+2], es
  call XMSaddr               
  ret                        
                             
xms_put:                     
;-----------------------------------------------------------------------------
; input:  bx = handle, es = source segment
; output: none                    
;-----------------------------------------------------------------------------
  mov  ah, 0bh                    
  mov  si, o xmsstruct 
  mov  xmsLength, 65536
  mov  xmsDestHandle, bx
  mov  xmsDestOffset, 0      
  mov  xmsSourceHandle, 0           
  mov  w [xmsSourceOffset], 0
  mov  w [xmsSourceOffset+2], es
  call XMSaddr                    
  ret                             
                                  
sine_init:                        
;-----------------------------------------------------------------------------
; input:  none
; output: none 
;-----------------------------------------------------------------------------
  mov  ax, data
  mov  es, ax
  mov  di, o sintable
  mov  x, 128
  mov  cx, 256
sin_loop:    
    mov   a, cx             ; sin=angle*pi*2/256=angle*pi/128
    fldpi     
    fimul a   
    fidiv _128
    fsin      
    fimul x        
    fistp a   
    mov   ax, a
    stosw     
    dec   cx  
  jnz  sin_loop
  mov  di, o costable
  mov  cx, 256  
cos_loop:       
    mov   a, cx             ; cos=angle*pi*2/256=angle*pi/128
    fldpi                        
    fimul a                      
    fidiv _128                   
    fcos     
    fimul x  
    fistp a                      
    mov   ax, a                  
    stosw                        
    dec   cx                     
  jnz  cos_loop                  
  ret                            
                                 
zero_fill:
;-----------------------------------------------------------------------------
; input:  es = target segment
; output: none
;-----------------------------------------------------------------------------
  xor  di, di      
  mov  cx, 65535/4  
  xor  eax, eax
  rep  stosd  
  ret         
       
tile_init:
;-----------------------------------------------------------------------------
; input:  es = target segment
; output: none
;-----------------------------------------------------------------------------
  mov  ax, dataseg1
  mov  es, ax
  xor  di, di
  mov  cx, 7 
tileloop:
    push cx        
    mov  si, o tile
    mov  bx, 32  
    cmp  cx, 7   
    jb   tiley
    mov  bx, 8
tiley:          
    mov  cx, 10
tilex:         
      push cx  
      push si   
      mov  cx, 8
      rep  movsd
      pop  si        
      pop  cx        
      dec  cx        
    jnz  tilex  
    add  si, 32 
    dec  bx     
  jnz  tiley
  pop  cx
  dec  cx     
  jnz  tileloop
  mov  bx, xhandle6
  call xms_put 
  ret           
         
wait_pattern:
;-----------------------------------------------------------------------------
; input:  bx = pattern, cx = row
; output: none        
;-----------------------------------------------------------------------------
  push es             
  mov  ax, sound      
  mov  es, ax         
wait_pat:             
    cmp  es:Row, cl
    jnz  wait_pat
    cmp  es:OrderPos, bl
    jnz  wait_pat
  pop  es
  ret

delay:
;-----------------------------------------------------------------------------
; input:  cx = delay
; output: none
;-----------------------------------------------------------------------------
  mov  timer_count, cx
loopdl:
    cmp  timer_count, 0
  jg   loopdl
  ret

keyboard_isr:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  push ax
  mov  al, 20h
  out  20h, al
  in   al, 60h
  dec  al
  add  al, escape
  jz   abort
  pop  ax
  iret
abort:
  jmp  system_shutdown

null_routine:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  ret

user_handler proc far
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  dec  timer_count
  inc  frame_count
  mov  curRow, ax
  mov  ax, bx
  mov  curPos, ax
  call user_routine
  ret
user_handler endp
