;
; primitive graphics functions
;

grafix_init:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  mov  ax, 13h
  int  10h
  ret
                 
grafix_initx:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  mov    ax, 13h
  int    10h       
  mov    dx, 03c4h 
  mov    al, 04h   
  out    dx, al    
  inc    dx        
  in     al, dx    
  and    al, 0c7h  
  or     al, 04h   
  out    dx, al    
  mov    dx, 03c4h 
  mov    al, 02h   
  out    dx, al    
  inc    dx        
  mov    al, 0fh   
  out    dx, al    
  mov    ax, 0a000h
  mov    es, ax    
  sub    di, di    
  mov    ax, di    
  mov    cx, 8000h 
  rep    stosw                                                                     
  mov    dx, 03d4h 
  mov    al, 14h   
  out    dx, al    
  inc    dx        
  in     al, dx    
  and    al, 0bFh  
  out    dx, al    
  dec    dx        
  mov    al, 17h   
  out    dx, al    
  inc    dx        
  in     al, dx    
  or     al, 40h   
  out    dx, al    
  mov    dx, 3d4h
  mov    al, 13h
  out    dx, al
  inc    dx    
  mov    al, 80
  ret

set_offset:
;-----------------------------------------------------------------------------
; input:  bx = offset
; output: none       
;-----------------------------------------------------------------------------
  mov     dx, 3d4h
  mov     al, 0ch
  mov     ah, bh  
  out     dx, ax  
  inc     al     
  mov     ah, bl
  out     dx, ax  
  ret            
                 
get_palette:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  mov  ax, data
  mov  es, ax
  mov  di, o palette
  mov  dx, 3c7h
  xor  al, al
  out  dx, al
  inc  dx
  inc  dx
  mov  cx, 768
  rep  insb
  ret
       
set_palette:
;-----------------------------------------------------------------------------
; input:  si = palette
; output: none
;-----------------------------------------------------------------------------
  mov  cx, 768
  mov  dx, 3c8h
  xor  al, al
  out  dx, al
  inc  dx
  rep  outsb
  ret    
       
black: 
;-----------------------------------------------------------------------------
; input:  si = palette
; output: none
;-----------------------------------------------------------------------------
  mov  cx, 768
  mov  dx, 3c8h
  xor  al, al
  out  dx, al
  inc  dx
baloop:
    out  dx, al
    dec  cx
  jnz  baloop
  ret   
        
initflashfade:  
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  call get_palette
  mov  si, o palette
  mov  di, o palette2
  mov  cx, 768
  mov  al, 63
  rep  stosb 
  mov  si, o palette2
  call set_palette
  mov  fadeval, 0
  mov  lz, 512
                 
flashfade:       
;-----------------------------------------------------------------------------
; input:  none   
; output: none   
;-----------------------------------------------------------------------------
  mov  ax, fadeval
  cmp  ax, 32
  je   flashnot
  inc  ax
  add  lz, 8
  mov  fadeval, ax
    mov  cx, 768  
    mov  si, o palette
    mov  di, o palette2
ffcloop:         
      mov  al, ds:[di]
      mov  ah, ds:[si]
      cmp  al, ah
      je   fcskip
      dec  al    
      cmp  al, ah
      je   fcskip
      dec  al  
fcskip:mov ds:[di], al
      inc  si  
      inc  di  
      dec  cx
    jnz  ffcloop  
    mov  si, o palette2
    call set_palette
flashnot:         
  ret             
                  
flash:            
;-----------------------------------------------------------------------------
; input:  none    
; output: none    
;-----------------------------------------------------------------------------
  call get_palette
  mov  si, o palette
  mov  di, o palette2
  mov  cx, 768 
  mov  al, 63  
  rep  stosb   
  mov  si, o palette2
  call set_palette
  call draw_screen
  mov  bp, 31  
floop:         
    mov  cx, 768
    mov  si, o palette
    mov  di, o palette2
fcloop:
      mov  al, es:[di]
      mov  ah, es:[si]
      cmp  al, ah
      je   cskip
      dec  al
      cmp  al, ah
      je   cskip
      dec  al
cskip:mov  es:[di], al
      inc  si
      inc  di
      dec  cx
    jnz  fcloop
    mov  si, o palette2
    call set_palette
    call wait_retrace
    dec  bp
  jnz  floop
  ret          
               
put_sprite:    
;-----------------------------------------------------------------------------
; input:  fs:si=sprite, es=target segment, x,y=offset
; output: none 
;-----------------------------------------------------------------------------
  mov  cx, fs:[si]
  mov  bp, fs:[si+2]
  dec  bp
  mov  bx, y
  mov  di, bx  
  shl  di, 8   
  shl  bx, 6   
  add  di, bx                           
  add  di, x                            
  mov  bx, si                           
  add  si, 4   
spriteyloop:                            
    mov  cx, fs:[bx] ; cx=xsize,bp=ysize
    mov  ax, x
    mov  xa, ax
spritexloop:   
      inc  xa  
      cmp  xa, 0
      jle  sprskip
      cmp  xa, 319
      ja   sprskip
      mov  al, fs:[si]
      mov  es:[di], al
sprskip:          
      inc  si     
      inc  di     
      dec  cx     
    jnz  spritexloop
    mov  ax, 320
    sub  ax, fs:[bx]
    add  di, ax
    dec  bp         
  jnz  spriteyloop
  ret             
                   
put_sprite2:       
;-----------------------------------------------------------------------------
; input:  fs:si=sprite, es=target segment, x,y=offset
; output: none     
;-----------------------------------------------------------------------------
  mov  gs, dataseg1
  mov  cx, fs:[si] 
  mov  bp, fs:[si+2]
  dec  bp          
  mov  bx, y       
  mov  di, bx      
  shl  di, 8       
  shl  bx, 6       
  add  di, bx                           
  add  di, x                            
  mov  bx, si                           
  add  si, 4       
spriteyloop2:                            
    mov  cx, fs:[bx] ; cx=xsize,bp=ysize
    mov  ax, x     
    mov  xa, ax    
spritexloop2:      
      inc  xa      
      cmp  xa, 0   
      jle  sprskip2
      cmp  xa, 319 
      ja   sprskip2
      mov  al, fs:[si]
      cmp  cx, 10
      jbe  sprskip1
      or   al, al  
      jnz  sprskip1
      mov  al, gs:[di]
sprskip1:          
      mov  es:[di], al
sprskip2:          
      inc  si      
      inc  di      
      dec  cx      
    jnz  spritexloop2
    mov  ax, 320     
    sub  ax, fs:[bx] 
    add  di, ax      
    dec  bp          
  jnz  spriteyloop2
  ret                
                   
fadein:            
;-----------------------------------------------------------------------------
; input:  none     
; output: none     
;-----------------------------------------------------------------------------
  call get_palette
  mov  di, o palette2
  mov  cx, 768
  xor  al, al
  rep  stosb
  mov  si, o palette2
  call set_palette
  call draw_screen
  mov  bp, 63
filoop:
    mov  cx, 768
    mov  si, o palette
    mov  di, o palette2
ficloop:
      mov  al, es:[di]
      mov  ah, es:[si]
      cmp  al, ah
      jb   cinc
      cmp  al, ah
      ja   cdec
      jmp  iskip
cdec: dec  al
      jmp  iskip
cinc: inc  al
iskip:mov  es:[di], al
      inc  si
      inc  di
      dec  cx
    jnz  ficloop
    mov  si, o palette2
    call set_palette
    call wait_retrace
    dec  bp
  jnz  filoop
  ret
 
fadeout:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  call get_palette
  mov  bp, 63
fdloop:
    mov  cx, 768
    mov  si, o palette
foloop:
      mov  al, es:[si]
      or   al, al
      jz   oskip
      dec  al
oskip:mov  es:[si], al
      inc  si
      dec  cx        
    jnz  foloop
    mov  si, o palette
    call set_palette
    call wait_retrace
    dec  bp
  jnz  fdloop
  movseg es, scrnSeg
  call zero_fill
  ret
          
draw_text:         
;-----------------------------------------------------------------------------
; input:  ds:si = string offset, es:di=offset, al = color
; output: none     
;-----------------------------------------------------------------------------
    mov  ah, al
draw_textL:    
    xor  bh, bh    
    mov  bl, ds:[si] 
    or   bl, bl     
    jz   draw_textdone
    sub  bl, 32    
    shl  bx, 6     
    push di         
    inc  si         
    mov  cl, 7
draw_textY:         
      mov  ch, 8    
draw_textXl:
        mov  al, 64
        sub  al, ds:font1[bx]
        inc  bx      
        add  al, ah  
        stosb        
        dec  ch      
      jnz  draw_textXl
      add  di, 320-8
      dec  cl        
    jnz  draw_textY        
    pop  di     
    add  di, 8  
  jmp  draw_textL
draw_textdone:     
  ret              
               
draw_textbig:  
;-----------------------------------------------------------------------------
; input:  ds:si = string offset, es:di=offset, al = color
; output: none     
;-----------------------------------------------------------------------------
    push di
    mov  bx, moredata
    mov  fs, bx
    mov  ah, al
draw_textbL:   
    xor  bh, bh    
    mov  bl, ds:[si] 
    inc  si
    or   bl, bl          
    jz   draw_textbdone  
    cmp  bl, 32
    je   draw_textbnext
    sub  bl, 65        
    imul bx, 961       
    push di              
    mov  bp, 31        
draw_textbY:             
      mov  cx, 31      
draw_textbXl:            
        mov  al, fs:font2[bx]
        inc  bx        
        add  al, ah    
        stosb        
        dec  cx
      jnz  draw_textbXl
      add  di, 320-31
      dec  bp
    jnz  draw_textbY        
    pop  di          
draw_textbnext:        
    add  di, 31
  jmp  draw_textbL   
draw_textbdone:      
  pop  di 
  ret                
             
draw_textX:  
;-----------------------------------------------------------------------------
; input:  ds:si = string offset, es:di=offset, al = color
; output: none     
;-----------------------------------------------------------------------------
    mov  ah, al    
    mov  dx, 40    
draw_textLX:       
    xor  bh, bh    
    mov  bl, ds:[si]
    dec  dx        
    jz   draw_textdoneX
    sub  bl, 32        
    shl  bx, 6         
    push edi            
    inc  si            
    mov  cl, 7
draw_textYX:           
      mov  ch, 8       
draw_textXX:           
        mov  al, 64
        sub  al, ds:font1[bx]
        inc  bx        
        add  al, ah    
        push dx    
        push edi    
        push cx    
        push ax    
        mov  cx, di
        shr  edi, 2 
        and  cx, 3 
        mov  ah, 1 
        shl  ah, cl
        mov  dx, 3c4h
        mov  al, 2 
        out  dx, ax
        pop  ax    
        mov  es:[di], al
        pop  cx    
        pop  edi    
        pop  dx
        inc  edi    
        dec  ch        
      jnz  draw_textXX
      add  edi, 320-8   
      dec  cl          
    jnz  draw_textYX
    pop  edi            
    add  edi, 8         
  jmp  draw_textLX
draw_textdoneX:
  ret              
                  
draw_screen:
;-----------------------------------------------------------------------------
; input:  none 
; output: none 
;-----------------------------------------------------------------------------
  push ds      
  push es      
  cld   
  mov  ds, virtseg
  movseg es, scrnSeg
  xor  si, si
  xor  di, di
  mov  cx, 16000
  rep  movsd
  pop  es
  pop  ds
  ret  
       
draw_fx:
;-----------------------------------------------------------------------------
; input:  none 
; output: none 
;-----------------------------------------------------------------------------
  mov   es, virtseg
  xor   di, di
  mov   cx, 16000
drawfxloop:
    mov   eax, d es:[di]
.486                  
    bswap eax    
.386             
    mov   d es:[di], eax
    add   di, 4
    dec   cx
  jnz  drawfxloop
  ret       
      
draw_glasses:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  mov  ax, moredata
  mov  fs, ax
  mov  es, virtseg
  mov  cx, 113*320
  mov  si, o glasses_data
  mov  di, 44*320
glassesloop:      
    mov  al, fs:[si]
    or   al, al   
    jz   noglass
    cmp  al, 32   
    je   drawglass
drawnorm:       
    mov  b es:[di], al
    jmp  noglass        
drawglass:            
    sub  b es:[di], 64        
noglass:
    inc  si
    inc  di
    dec  cx
  jnz glassesloop
  ret                
          
soften:           
;-----------------------------------------------------------------------------
; input:  es = target segment
; output: none    
;-----------------------------------------------------------------------------
  xor  di, di
  mov  bx, 320
softloop:
    xor  ah, ah
    mov  al, es:[di+1]
    mov  dx, ax
    mov  al, es:[di-1]
    add  dx, ax
    mov  al, es:[di+bx]
    add  dx, ax
    mov  al, es:[di+320]
    add  dx, ax
    shr  dx, 2
    or   dl, dl
    jz   softzero
    dec  dl
softzero:
    mov  es:[di+320], dl
    inc  di
  jnz  softloop
  ret

draw_offset:
;-----------------------------------------------------------------------------
; input:  bx = offset
; output: none                                                                
;-----------------------------------------------------------------------------
  push ds  
  mov  ax, virtseg
  mov  ds, ax
  mov  ax, scrnseg
  mov  es, ax
  mov  cx, 200
  mov  di, bx
  xor  si, si
  mov  dx, 320
  sub  dx, bx       ; bx = ofs, dx = len
draw_oloop:                             
    push cx                             
    mov  cx, dx
    shr  cx, 2
    rep  movsd
    pop  cx
    add  di, bx
    add  si, bx
    dec  cx
  jnz  draw_oloop
  pop  ds       
  ret           
              
wait_retrace: 
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  mov  dx, 3dah
w1: 
  in   al, dx
  and  al, 8
  jz   w1
w2:
  in   al, dx
  and  al, 8
  jnz  w2
  ret
  