;
; this is tinyplay by carlos hasan (i think), after i raped it abit.
;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; equates                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
     
  NumTracks       equ     4
  DefTempo        equ     6
  DefBpm          equ     125
  MidCRate        equ     8448
  MixBufSize      equ     4096
  DmaBufSize      equ     2048
  TimerFreq       equ     17045    ; 70 times/sec
  w               equ     word ptr
  o               equ     offset
                                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; macros                                                                   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                                
sbOut macro data                
local sbWait                    
sbWait:
    in  al, dx
    or  al, al
  js  sbWait
  mov al, data
  out dx, al
endm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; code (user routines)                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AskConfig:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  push cs
  pop  ds
  mov  ah, 9
  mov  dx, o askPort
  int  21h  
askLoop1:   
    mov  ah, 7
    int  21h
    sub  al, '1'
    cmp  al, 6
  ja   askLoop1
  mov  dl, al
  add  dl, '1'
  xor  bh, bh
  mov  bl, al  
  shl  bx, 1
  mov  ax, PortTable[bx]
  mov  sbAddr, ax
  cmp  ax, 0
  jz   DoneConfig
  mov  ah, 2
  int  21h
  mov  ah, 9
  mov  dx, o askIrq
  int  21h         
askLoop2:               
    mov  ah, 7 
    int  21h   
    sub  al, '1'
    cmp  al, 5
  ja    askLoop2
  mov   dl, al
  add   dl, '1'
  xor   bh, bh
  mov   bl, al
  shl   bx, 1
  mov   ax, IrqTable[bx]
  mov   sbIrq, ax
  mov   ah, 2
  int   21h
DoneConfig:
  mov   ah, 9
  mov   dx, o crlf
  int   21h        
  ret
               
LoadModule:    
;-----------------------------------------------------------------------------
; input:  ds:dx = asciiz filename
; output: none                   
;-----------------------------------------------------------------------------
  pusha                          
  push ds                        
  push es                        
  mov  cs:modoffset, offset music_data
  mov  ErrorInfo, 1              
  call ClearModInfo              
;  mov  ax, 3D00h                
;  int  21h                      
;  jc   Failed                   
;  mov  [FileHandle], ax         
;  mov  bx, ax                   
  push cs                        
  pop  ds                        
;  mov  ax, 3F00h                
;  mov  cx, size ModHeader       
;  lea  dx, Header               
;  int  21h                      
;  jc   CloseFile                
  mov  cx, size ModHeader        
  lea  dx, Header
  call GetModule                 
  mov  al, Header.mhOrderLen     
  mov  ModInfo.miOrderLen, al    
  mov  al, Header.mhReStart      
  cmp  al, Header.mhOrderLen     
  jb   SetReStart                
  mov  al, 7Fh                   
SetReStart:                      
  mov  ModInfo.miRestart, al     
  mov  cx, 128                   
  xor  ax, ax                    
  xor  bx, bx                    
CopyOrder:                       
    mov  ah, [Header.mhOrder+bx] 
    mov  [ModInfo.miOrder+bx], ah
    cmp  ah, al                  
    jb   NextOrder               
    mov  al, ah                  
NextOrder:                       
    inc  bx                      
  loop CopyOrder                 
  xor  bx, bx                    
  mov  bl, al                    
  inc  bx                        
  push bx                        
  shl  bx, 6                     
  mov  ax, 4800h                 
  int  21h                       
  pop  bx                        
  jc   CloseFile                 
  mov  Word Ptr [ModInfo.mhPatterns], 0
  mov  Word Ptr [ModInfo.mhPatterns+2], ax
  push ds                        
;  mov  ax, 3F00h                 
  mov  cx, bx                    
  shl  cx, 10
;  mov  bx, FileHandle            
  lds  dx, ModInfo.mhPatterns    
;  int  21h                       
  call GetModule
  pop  ds                        
; jc   CloseFile
  lea  si, Header.mhSamples
  xor  di, di
CopySamples:
    mov  ax, [si+msLength]
    xchg al, ah
    shl  ax, 1
    mov  [ModInfo.mhSampLen+di], ax
    mov  al, [si+msVolume]
    xor  ah, ah
    mov  [ModInfo.mhSampVol+di], ax
    mov  ax, [si+msRepeat]
    xchg al, ah
    shl  ax, 1
    mov  [ModInfo.mhSampRep+di], ax
    mov  ax, [si+msRepLen]
    xchg al, ah
    shl  ax, 1  
    mov  [ModInfo.mhSampRepLen+di], ax
    add  si, size ModSample
    add  di, 2
    cmp  di, 2*31
  jb   CopySamples
  xor  si,si
AllocSamples:
    mov  bx, [ModInfo.mhSampLen+si]
    shr  bx, 4
    je   NextSample
    push si
    inc  bx
    mov  ax, 4800h
    int  21h
    pop  si
    jc   CloseFile
    mov  [ModInfo.mhSampOfs+si], 0
    mov  [ModInfo.mhSampSeg+si], ax
    push si     
    push ds
;    mov  ax, 3F00h
;    mov  bx, FileHandle
    mov  cx, [ModInfo.mhSampLen+si]
    mov  dx, [ModInfo.mhSampOfs+si]
    mov  ds, [ModInfo.mhSampSeg+si]
;    int  21h
    call GetModule
    pop  ds       
    pop  si
;   jc   CloseFile
NextSample:
    add  si, 2
    cmp  si, 2*31
  jb   AllocSamples
  mov  ErrorInfo, 0
CloseFile:
;  mov  ax, 3E00h
;  mov  bx, FileHandle
;  int  21h      
Failed:
  clc
  cmp  ErrorInfo, 0
  je   NoError
  stc       
NoError:
  pop  es
  pop  ds
  popa         
  ret

FreeModule:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  pusha
  push ds
  push es       
  push cs
  pop  ds
  mov  ax, 4900h
  mov  bx, w [ModInfo.mhPatterns+2]
  test bx, bx
  je   FreeSamples
  mov  es, bx
  int  21h
FreeSamples:
  xor  si, si  
FreeLoop:
    mov  ax, [ModInfo.mhSampLen+si]
    mov  bx, [ModInfo.mhSampSeg+si]
    test ax, ax
    je   FreeNext
    test bx, bx
    je   FreeNext
    push si
    mov  ax, 4900h
    mov  es, bx
    int  21h
    pop  si
FreeNext:
    add  si, 2
    cmp  si, 2*31
  jb   FreeLoop
  call ClearModInfo
  pop  es
  pop  ds
  popa         
  ret

StartPlayer:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  pusha         
  push ds
  push es
  mov  ax, sbAddr
  cmp  ax, 0
  je   initNoSound
  call InitPlayer
  cli
  in   al, 21h
  push ax
  mov  al, 0ffh
  out  21h, al
  mov  DmaFlag, 0
  mov  ax, o DoubleBuffer
  mov  DmaBuffer, ax
  mov  dx, ds
  mov  bx, dx
  shr  dh, 4
  shl  bx, 4
  add  ax, bx   
  adc  dh, 0
  mov  cx, ax
  neg  cx
  cmp  cx, DmaBufSize
  jae  SetDma
  add  DmaBuffer, cx
  add  ax, cx
  adc  dh, 0
SetDma:
  mov  bx, ax  
  mov  cx, DmaBufSize
  dec  cx
  mov  al, 05h
  out  0Ah, al
  xor  al, al
  out  0Ch, al
  mov  al, bl
  out  02h, al
  mov  al, bh   
  out  02h, al
  mov  al, dh
  out  83h, al
  mov  al, cl
  out  03h, al
  mov  al, ch
  out  03h, al
  mov  al, 59h
  out  0Bh, al
  mov  al, 01h
  out  0Ah, al 
  mov  di, DmaBuffer
  mov  cx, DmaBufSize
  mov  ax, ds
  mov  es, ax
  mov  al, 80h
  cld
  rep  stosb
  xor  ax, ax   
  mov  es, ax
  mov  bx, SbIrq
  add  bx, 08h
  shl  bx, 2
  mov  ax, es:[bx]
  mov  dx, es:[bx+2]
  mov  w [DmaHandler], ax
  mov  w [DmaHandler+2], dx
  mov  ax, o SbIrqHandler
  mov  es:[bx], ax
  mov  es:[bx+2], cs
  mov  dx, SbAddr
  add  dx, 06h
  mov  al, 1
  out  dx, al
  in   al, dx
  in   al, dx
  in   al, dx
  in   al, dx   
  xor  al, al
  out  dx, al   
  mov  cx, 128
WaitId:
    mov  dx, SbAddr
    add  dx, 0Eh
    in   al, dx
    or   al, al
    js   GetID
  loop WaitId
  jmp  sbExit
GetId:
    mov  dx, SbAddr
    add  dx, 0Ah
    in   al, dx
    cmp  al, 0AAh
    je   SbOk
  loop WaitId
  jmp  sbExit   
SbOk:
  mov   dx, SbAddr
  add   dx, 0Ch
  sbOut 0D1h
  mov   ax, 1000
  mul   ax
  div   MixSpeed
  neg   al
  mov   ah, al
  mov   dx, SbAddr
  add   dx, 0Ch
  sbOut 40h
  sbOut ah
  sbOut 14h
  sbOut 0FFh
  sbout 0FFh
sbExit:
  pop  ax
  mov  cx, SbIrq
  mov  ah, 1
  shl  ah, cl   
  not  ah
  and  al, ah
  out  21h, al
InitNoSound:
  mov  ax, es:[70h]
  mov  dx, es:[72h]
  mov  w [TimerHandler], ax
  mov  w [TimerHandler+2], dx
  mov  ax, o sbTimerHandler
  mov  es:[70h], ax
  mov  es:[72h], cs
  mov  al, 36h 
  out  43h, al
  mov  ax, TimerFreq
  out  40h, al
  mov  al, ah
  out  40h, al  
  sti
  pop  es       
  pop  ds      
  popa
  ret

StopPlayer:
;-----------------------------------------------------------------------------
; input:  none
; output: none
;-----------------------------------------------------------------------------
  pusha
  push  ds
  push  es
  mov   ax, sbAddr
  cmp   ax, 0
  jz    StopNoSound
  cli
  in    al, 21h 
  push  ax
  mov   al, 0FFh
  out   21h, al
  xor   ax, ax
  mov   es, ax
  mov   bx, SbIrq
  add   bx, 08h
  shl   bx, 2
  mov   ax, w [DmaHandler]
  mov   dx, w [DmaHandler+2]
  mov   es:[bx], ax
  mov   es:[bx+2], dx
  mov   dx, SbAddr
  add   dx, 0Ch
  sbOut 0D0h
  sbOut 0D3h   
  pop   ax
  mov   cx, SbIrq
  mov   ah, 1   
  shl   ah, cl
  or    al, ah  
  out   21h, al
StopNoSound:
  mov   ax, w [TimerHandler]
  mov   dx, w [TimerHandler+2]
  mov   es:[70h], ax
  mov   es:[72h], dx
  mov   al, 36h 
  out   43h, al
  xor   al, al
  out   40h, al
  out   40h, al
  sti
  pop   es
  pop   ds
  popa
  ret    
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; code (internal routines)                                                 ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
GetModule: ; cx=size ds:dx=target
;-----------------------------------------------------------------------------                
  pusha  
  push ds
  push es
  cld    
  mov  ax, ds
  mov  es, ax
  mov  ax, data
  mov  ds, ax
  mov  si, cs:modoffset
  mov  di, dx 
  push cx
  rep  movsb  
  pop  cx
  add  cs:modoffset, cx
  pop  es       
  pop  ds     
  popa   
  ret

ClearModInfo:
;-----------------------------------------------------------------------------
  pusha         
  push es       
  push cs       
  pop  es       
  lea  di, ModInfo
  mov  cx, size ModInfoRec
  cld           
  xor  ax, ax   
  rep  stosb    
  pop  es
  popa
  ret
                
sbIrqHandler:
;-----------------------------------------------------------------------------
  push  ax
  push  dx
  mov   dx, cs:SbAddr
  add   dx, 0Eh
  in    al, dx
  sub   dx, 02h
  sbOut 14h    
  sbOut 0FFh
  sbOut 0FFh
  mov   al, 20h
  out   20h, al
  pop   dx
  pop   ax
  iret

sbTimerHandler:
;-----------------------------------------------------------------------------
  pusha         
  push ds       
  push es       
  push cs       
  pop  ds       
  in   al, 03h  
  mov  cl, al   
  in   al, 03h  
  mov  ch, al   
  mov  ax, DmaFlag
  test ax, ax   
  jne  SecondHalf
  cmp  cx, DmaBufSize/2
  jae  pollDone 
  mov  di, DmaBuffer
  call GetSamples
  inc  DmaFlag  
  jmp  pollDone 
SecondHalf:     
  cmp  cx, DmaBufSize/2
  jb   pollDone 
  mov  di, DmaBuffer
  add  di, DmaBufSize/2
  call GetSamples
  dec  DmaFlag  
pollDone:       
  mov     ax, data
  mov     ds, ax
  xor     ax, ax
  xor     bx, bx
  mov     al, cs:Row
  mov     bl, cs:OrderPos
  call    user_handler
  pop     es    
  pop     ds    
  popa
  iret         

BeatTrack:
;-----------------------------------------------------------------------------
  mov  dx, [di+Effect]
  cmp  dh, 00h
  je   Arpeggio
  cmp  dh, 01h
  je   PortUp   
  cmp  dh, 02h  
  je   PortDown
  cmp  dh, 03h
  je   TonePort
  cmp  dh, 04h
  je   Vibrato
  cmp  dh, 05h
  je   PortSlide
  cmp  dh, 06h
  je   VibSlide
  cmp  dh, 0Ah
  je   VolSlide
  ret

Arpeggio:
  mov  bx, [di+ArpIndex]
  mov  ax, [di+Arp+bx]
  mov  [di+Pitch], ax
  add  bx, 2
  cmp  bx, 6
  jb   SetArpIndex
  xor  bx, bx
SetArpIndex:
  mov  [di+ArpIndex], bx
  ret

PortUp:
  xor  dh, dh
  mov  bx, [di+Period]
  sub  bx, dx
  cmp  bx, 113
  jge  NotSmall
  mov  bx, 113
NotSmall:
  mov  [di+Period], bx
  add  bx, bx
  mov  ax, [PitchTable+bx]
  mov  [di+Pitch], ax
  ret

PortDown:
  xor  dh, dh
  mov  bx, [di+Period]
  add  bx, dx
  cmp  bx, 856
  jle  NotBig
  mov  bx, 856
NotBig:
  mov  [di+Period], bx
  add  bx, bx
  mov  ax, [PitchTable+bx]
  mov  [di+Pitch], ax
  ret

TonePort:
  xor  dh, dh
  mov  ax, [di+PortTo]
  mov  bx, [di+Period]
  cmp  bx, ax
  je   NoPort
  jg   PortToUp
PortToDown:
  add  bx, dx
  cmp  bx, ax
  jle  SetPort
FixPort:
  mov  bx, ax
  jmp  SetPort
PortToUp:
  sub  bx, dx
  cmp  bx, ax
  jl   FixPort 
SetPort:
  mov  [di+Period], bx
  add  bx, bx
  mov  ax, [PitchTable+bx]
  mov  [di+Pitch], ax
NoPort:
  ret

Vibrato:
  mov  dh, dl
  and  dl, 0Fh
  shr  dh, 4
  shl  dh, 2
  add  [di+VibPos], dh
  mov  dh, [di+VibPos]
  mov  bl, dh
  shr  bl, 2
  and  bx, 1Fh
  mov  al, [mSinTable+bx]
  mul  dl      
  rol  ax, 1
  xchg al, ah
  and  ah, 1
  test dh, dh
  jns  VibUp
  neg  ax
VibUp:
  add  ax, [di+Period]
  mov  bx, ax
  cmp  bx, 113
  jge  NoLoVib
  mov  bx, 113
NoLoVib:
  cmp  bx, 856
  jle  NoHiVib
  mov  bx, 856
NoHiVib:
  add  bx, bx
  mov  ax, [PitchTable+bx]
  mov  [di+Pitch], ax
  ret

PortSlide:
  call VolSlide
  mov  dl, [di+PortParm]
  jmp  TonePort

VibSlide:
  call VolSlide
  mov  dl, [di+VibParm]
  jmp  Vibrato

VolSlide:
  mov  dh, dl
  and  dl, 0Fh
  shr  dh, 4
  mov  al, [di+Volume]
  sub  al, dl
  jge  NoLoVol
  xor  al, al  
NoLoVol:
  add  al, dh
  cmp  al, 64
  jbe  NoHiVol
  mov  al, 64
NoHiVol:
  mov  [di+Volume], al
  ret

GetTrack:
;-----------------------------------------------------------------------------
  seges lodsw
  xchg  al, ah
  mov   bl, ah
  and   ah, 0Fh
  mov   cx, ax
  seges lodsw
  xchg  al, ah
  mov   bh, ah
  and   ah, 0Fh
  mov   dx, ax
  mov   [di+Effect], dx
  and   bl, 0F0h
  shr   bh, 4
  or    bl, bh
  je    SetPeriod
  xor   bh, bh
  dec   bx
  add   bx, bx
  mov   ax, [SampVol+bx]
  mov   [di+Volume], al
  mov   ax, [SampOfs+bx]
  mov   w [di+Samples], ax
  mov   ax, [SampSeg+bx]
  mov   w [di+Samples+2], ax
  mov   ax, [SampLen+bx]
  mov   [di+Len], ax
  mov   ax, [SampRep+bx]
  mov   [di+Repeat], ax
  mov   ax, [SampRepLen+bx]
  mov   [di+RepLen], ax
SetPeriod:
  and   cx, cx
  je    SetEffect
  mov   [di+PortTo], cx
  cmp   dh, 03h
  je    SetEffect
  mov   [di+Period], cx
  mov   bx, cx
  add   bx, bx
  mov   ax, [PitchTable+bx]
  mov   [di+Pitch], ax
  mov   [di+Position], 0
SetEffect:
  cmp   dh, 00h
  je    InitArpeggio
  cmp   dh, 03h
  je    InitTonePort
  cmp   dh, 04h
  je    InitVibrato
  cmp   dh, 09h
  je    SampleOfs
  cmp   dh, 0Bh
  je    PosJump
  cmp   dh, 0Ch
  je    SetVolume
  cmp   dh, 0Dh
  je    Break
  cmp   dh, 0Fh
  je    SetSpeed
  ret

InitTonePort:
  test  dl, dl
  jne   SetPortParm
  mov   dl, [di+PortParm]
SetPortParm:
  mov   [di+PortParm], dl
  mov   [di+Effect], dx
  ret          

InitVibrato:
  mov   al, [di+VibParm]
  mov   ah, al
  and   al, 0Fh
  and   ah, 0F0h
  test  dl, 0Fh
  jne   OkDepth
  or    dl, al
OkDepth:
  test  dl, 0F0h
  jne   OkRate
  or    dl, ah
OkRate:
  mov   [di+VibParm], dl
  mov   [di+Effect], dx
  test  cx, cx
  je    OkPos
  mov   [di+VibPos], 0
OkPos:         
  ret

SampleOfs:
  test  dl, dl
  jne   SetSampleOfs
  mov   dl, [di+OldSampOfs]
SetSampleOfs:
  mov   [di+OldSampOfs], dl
  mov   dh, dl
  xor   dl, dl
  mov   [di+Position], dx
  ret

PosJump:
  mov   OrderPos, dl
  mov   Row, 64
  ret

SetVolume:
  cmp   dl, 64 
  jbe   OkVol
  mov   dl, 64
OkVol:
  mov   [di+Volume], dl
  ret

Break:
  mov   dh, dl
  and   dl, 0Fh
  shr   dh, 4
  add   dh, dh
  add   dl, dh
  shl   dh, 2
  add   dl, dh
  mov   BreakRow, dl
  mov   Row, 64
  ret

SetSpeed:
  test  dl, dl 
  je    Skip
  cmp   dl, 31
  ja    SetBpm
  mov   Tempo, dl
  mov   TempoWait, dl
  ret
SetBpm:
  mov   Bpm, dl
  mov   al, 103
  mul   dl
  mov   bl, ah
  xor   bh, bh
  mov   ax, MixSpeed
  xor   dx, dx
  div   bx
  mov   BpmSamples, ax
Skip:
  ret

InitArpeggio:  
  mov   dh, dl
  and   dl, 0Fh
  shr   dh, 4
  mov   cx, 36
  xor   bx, bx
  mov   ax, [di+Period]
ScanPeriod:
    cmp   ax, [PeriodTable+bx]
    jae   SetArp
    add   bx, 2
  loop  ScanPeriod
SetArp:
  add   dx, dx
  add   dh, bl
  add   dl, bl
  mov   bx, [PeriodTable+bx]
  add   bx, bx
  mov   ax, [PitchTable+bx]
  mov   [di+Arp], ax
  mov   bl, dh 
  xor   bh, bh
  mov   bx, [PeriodTable+bx]
  add   bx, bx
  mov   ax, [PitchTable+bx]
  mov   [di+Arp+2], ax
  mov   bl, dl
  xor   bh, bh
  mov   bx, [PeriodTable+bx]
  add   bx, bx
  mov   ax, [PitchTable+bx]
  mov   [di+Arp+4], ax
  mov   [di+ArpIndex], 0
  ret

UpdateTracks:
;-----------------------------------------------------------------------------
  dec  [TempoWait]
  je   GetTracks

  ofs = o Tracks
  rept NumTracks
    mov   di, ofs
    call  BeatTrack
    ofs = ofs + size TrackInfo
  endm
  ret

GetTracks:
  mov  al, Tempo
  mov  TempoWait, al
  les  si, Note
  cmp  Row, 64
  jb   NoPattWrap
  les  si, Patterns
  mov  bl, OrderPos
  cmp  bl, OrderLen
  jb   NoOrderWrap
  mov  bl, ReStart
  mov  OrderPos, bl
  cmp  bl, OrderLen
  jae  NoUpdate
NoOrderWrap:
  xor  bh, bh
  mov  bl, [Order+bx]
  shl  bx, 10
  add  si, bx
  mov  bl, BreakRow
  mov  Row, bl
  xor  bh, bh
  mov  BreakRow, bh
  shl  bx, 4
  add  si, bx
  mov  w [Note], si
  mov  w [Note+2], es
  inc  OrderPos
NoPattWrap:
  inc  Row
  cld

  ofs = o Tracks
  rept NumTracks
    mov   di, ofs
    call  GetTrack
    ofs = ofs + size TrackInfo
  endm

  mov  w [Note], si
NoUpdate:
  ret

MixTrack:
;-----------------------------------------------------------------------------
  cmp  [si+RepLen], 2
  ja   MixLooped
  les  dx, [si+Samples]
  mov  bx, [si+Position]
  mov  bp, [si+Len]
  push dx
  push si
  add  bx, dx  
  add  bp, dx
  mov  dx, [si+Pitch]
  mov  al, [si+Volume]
  mov  ah, [si+Error]
  mov  si, bx
  mov  bh, al
  mov  al, dl
  mov  dl, dh
  xor  dh, dh
nlMixSamp:
    cmp  si, bp
    jae  nlMixDone
    mov  bl, es:[si]
    mov  bl, [VolTable+bx]
    add  [di], bl
    inc  di
    add  ah, al
    adc  si, dx
  loop nlMixSamp
nlMixDone:     
  mov  bx, si
  pop  si
  pop  dx
  sub  bx, dx
  mov  [si+Position], bx
  mov  [si+Error], ah
  ret

MixLooped:
  les  dx, [si+Samples]
  mov  bx, [si+Position]
  mov  bp, [si+RepLen]
  mov  BufRep, bp
  add  bp, [si+Repeat]
  push dx
  push si
  add  bx, dx
  add  bp, dx
  mov  dx, [si+Pitch]
  mov  al, [si+Volume]
  mov  ah, [si+Error]
  mov  si, bx
  mov  bh, al
  mov  al, dl
  mov  dl, dh
  xor  dh, dh
lpMixSamp:
    cmp  si, bp
    jb   lpMixNow
    sub  si, BufRep
lpMixNow:
    mov  bl, es:[si]
    mov  bl, [VolTable+bx]
    add  [di], bl
    inc  di
    add  ah, al
    adc  si, dx
  loop lpMixSamp
  mov  bx, si
  pop  si      
  pop  dx
  sub  bx, dx
  mov  [si+Position], bx
  mov  [si+Error], ah
  ret

GetSamples:
;-----------------------------------------------------------------------------
  pusha
  push ds
  push es
  push cs
  pop  es
  cld
  mov  bx, DmaBufSize/2
NextChunk:
    cmp  BufLen, 0
    jne  CopyChunk
    push bx
    push di    
    push es
    lea  di, MixBuffer
    mov  cx, BpmSamples
    mov  BufPtr, di
    mov  BufLen, cx
    mov  ax, ds
    mov  es, ax
    mov  al, 80h
    rep  stosb

    ofs = o Tracks
    rept NumTracks
      mov   si, ofs
      mov   di, BufPtr
      mov   cx, BufLen
      call  MixTrack
      ofs = ofs + size TrackInfo
    endm

    call UpdateTracks
    pop  es
    pop  di
    pop  bx
CopyChunk:
    mov  cx, BufLen
    cmp  cx, bx
    jbe  MoveChunk
    mov  cx, bx
MoveChunk:
    mov  si, BufPtr
    add  BufPtr, cx
    sub  BufLen, cx
    sub  bx, cx
    rep  movsb
    test bx, bx
  jne  NextChunk
  pop  es
  pop  ds
  popa
  ret          

InitPlayer:
  pusha
  push ds
  push es
  mov  OrderPos, 0
  mov  Tempo, DefTempo
  mov  TempoWait, DefTempo
  mov  Bpm, DefBpm
  mov  Row, 64
  mov  BreakRow, 0
  mov  ax, MixSpeed
  xor  dx, dx
  mov  bx, 24*DefBpm/60
  div  bx
  mov  BpmSamples, ax
  mov  di, o Tracks
  mov  ax, ds
  mov  es, ax
  mov  cx, NumTracks*(size TrackInfo)
  xor  ax, ax
  cld
  rep  stosb
  mov  BufPtr, ax
  mov  BufLen, ax
  mov  ax, MidCRate
  mov  bx, 428
  mul  bx
  div  MixSpeed
  xor  dh, dh
  mov  dl, ah
  mov  ah, al
  xor  al, al
  mov  cx, 857 
  xor  bx, bx
  mov  di, o PitchTable
PitchLoop:
    push ax
    push dx
    cmp  dx, bx
    jae  NoDiv
    div  bx
NoDiv:
    stosw
    pop  dx
    pop  ax
    inc  bx
  loop PitchLoop
  mov  cx, 16640
  mov  bx, cx
VolLoop:
    dec  bx
    mov  al, bl
    imul bh    
    mov  [VolTable+bx], ah
  loop VolLoop
  pop  es
  pop  ds
  popa
  ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; structures                                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TrackInfo struc
  Samples    dd ?
  Position   dw ?
  Len        dw ?
  Repeat     dw ?
  RepLen     dw ?
  Volume     db ?
  Error      db ?
  Period     dw ?
  Pitch      dw ?
  Effect     dw ?
  PortTo     dw ?
  PortParm   db ?
  VibPos     db ?
  VibParm    db ?
  OldSampOfs db ?
  Arp        dw ?, ?, ?
  ArpIndex   dw ?
TrackInfo ends

ModSample struc
  msName     db 22 dup (?)
  msLength   dw ?
  msFinetune db ?
  msVolume   db ?
  msRepeat   dw ?
  msRepLen   dw ?
ModSample ends
               
ModHeader struc
  mhName     db        20 dup (?)
  mhSamples  ModSample 31 dup (?)
  mhOrderLen db        ?
  mhReStart  db        ?
  mhOrder    db        128 dup (?)
  mhSign     dw        ?, ?
ModHeader ends

ModInfoRec struc
  miOrder      db 128 dup (?)
  mhSampOfs    dw 31 dup (?)
  mhSampSeg    dw 31 dup (?)
  mhSampLen    dw 31 dup (?)
  mhSampRep    dw 31 dup (?)
  mhSampRepLen dw 31 dup (?)
  mhSampVol    dw 31 dup (?)
  miOrderLen   db ?
  miRestart    db ?
  mhPatterns   dd ?
ModInfoRec ends
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; data                                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  mSinTable    db 0,  25, 50, 74, 98, 120,142,162,180,197,212,225
               db 236,244,250,254,255,254,250,244,236,225,212,197
               db 180,162,142,120,98, 74, 50, 25
  PeriodTable  dw 856,808,762,720,678,640,604,570,538,508,480,453
               dw 428,404,381,360,339,320,302,285,269,254,240,226
               dw 214,202,190,180,170,160,151,143,135,127,120,113
  PortTable    dw 210h, 220h, 230h, 240h, 250h, 260h, 0
  IrqTable     dw 2,    3,    4,    5,    7,    9
  MixSpeed     dw 22528        
  crlf         db 0ah, 0dh, 24h
  askPort      db 'raped tinyplay soundsystem', 0ah, 0dh, 0ah, 0dh
               db 'select soundblaster port:', 0ah, 0dh
               db ' 1=210h, 2=220h, 3=230h, 4=240h, 5=250h, 6=260h', 0ah, 0dh
               db ' 7=nosound', 0ah, 0dh
               db '>', 24h  
  askIrq       db 0ah, 0dh, 0ah, 0dh
               db 'select soundblaster irq:', 0ah, 0dh
               db ' 1=2, 2=3, 3=4, 4=5, 5=7, 6=9', 0ah, 0dh
               db '>', 24h
                   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; uninitialized data                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
               
  ModInfo      label byte
  Order        db        128 dup (?)
  SampOfs      dw        31  dup (?)
  SampSeg      dw        31  dup (?)
  SampLen      dw        31  dup (?)
  SampRep      dw        31  dup (?)           
  SampRepLen   dw        31  dup (?)
  SampVol      dw        31  dup (?)           
  OrderLen     db        ?                     
  ReStart      db        ?
  Patterns     dd        ?
  Header       ModHeader ?
  Tracks       db        size TrackInfo*NumTracks dup (?) ; tasm sucks
  MixBuffer    db        MixBufSize               dup (?)
  DoubleBuffer db        2*DmaBufSize             dup (?)
  PitchTable   dw        857                      dup (?)
  VolTable     db        16384+256                dup (?)
  SbAddr       dw        ? 
  SbIrq        dw        ?     
  OrderPos     db        ?
  Tempo        db        ?
  TempoWait    db        ?
  Bpm          db        ?
  Row          db        ?
  BreakRow     db        ?
  BpmSamples   dw        ?
  BufPtr       dw        ?
  BufLen       dw        ?
  BufRep       dw        ?
  Note         dd        ?
  DmaFlag      dw        ?
  DmaBuffer    dw        ?
  FileHandle   dw        ?
  ErrorInfo    dw        ?
  DmaHandler   dd        ?
  TimerHandler dd        ?
