{ Converts multi-object ASCII MESH file to single-object ASCII MESH file
  Version 0.10
  Written by BoRZoM

  30 minutes work | 16/12/95
}

Uses CRT, DOS;

var
  x, y, z : Integer;
  t1, t2  : Text;
  s1, s2  : String;
  NumFace,
  NumVert,
  TmpFace,
  TmpVert : Integer;

{ (Vertex list:) Vertex [xx+n]
  (Face list:)   A:[xx+n] B:[xx+n] C:[xx+n] Face [xx+n2]

  done obj: n=n+numvert
            n2=n2+facenum
}

procedure Replace (var src : String; s : String; n : Integer);
var
  x, y, z : Integer;
  st      : String;
  num     : Integer;
Begin
  x := Pos (s, src);
  if x = 0 then Exit;
  x := x + Length (s);
  y := 0; z := x;
  While src [z] in ['0'..'9'] do begin
    inc (z);
    inc (y);
  end;
  { y = len, x = pos }
  st := copy (src, x, y);
  Val (st, num, z);
  If z <> 0 then exit;
  Delete (src, x, y);
  num := num + n;
  Str (num, st);
  Insert (St, Src, x);
End;

Function _st (l : Longint) : String;
var
  s : String;
Begin
  Str (l, s);
  _st := s;
End;

Begin
  Writeln (' CONVASC v0.10, written by BoRZoM ');
  If ParamCount < 2 then begin
    Writeln ('usage: CONVASC [Input_File.ASC] [Output_File.ASC]');
    Halt;
  End;
  Assign (t1, Paramstr (1));
  {$I-} Reset (t1); {$I+}
  If IOResult <> 0 then Begin
    Writeln ('error: File not found');
    Halt;
  End;
  Assign (t2, '##TEMP##.###');
  {$I-} Rewrite (t2); {$I+}
  If IOResult <> 0 then Begin
    Writeln ('error: Cannot create file');
    Halt;
  End;
  NumFace := 0; TmpFace := 0;
  NumVert := 0; TmpVert := 0;
  s1 := '';
  While (not eof (t1)) and (s1 <> 'Vertex list:') do begin
    readln (t1, s1);
    writeln (t2, s1);
  end;
  if eof (t1) then Begin
    Writeln ('error: Not an ascii mesh file');
    Halt;
  End;
  Write ('Converting...');
  While not eof (t1) do begin
    Readln (t1, s1);
    If s1 = 'Vertex list:' then Begin
      NumFace := NumFace + TmpFace;
      NumVert := NumVert + TmpVert;
      TmpFace := 0;
      TmpVert := 0;
    End;
    Replace (s1, 'Vertex ', NumVert);
    Replace (s1, 'Face ', NumFace);
    Replace (s1, ' A:', NumVert);
    Replace (s1, ' B:', NumVert);
    Replace (s1, ' C:', NumVert);
    If (Pos ('Vertex', s1)>0)and
       (Pos ('X:', s1)>0)and
       (Pos ('Y:', s1)>0)and
       (Pos ('Z:', s1)>0) then TmpVert := TmpVert + 1;
    If (Pos ('Face', s1)>0)and
       (Pos ('A:', s1)>0)and
       (Pos ('B:', s1)>0)and
       (Pos ('C:', s1)>0) then TmpFace := TmpFace + 1;
    Writeln (t2, s1);
  End;
  NumFace := NumFace + TmpFace;
  NumVert := NumVert + TmpVert;
  Writeln;
  Write ('Rebuilding...');
  Close (t1);
  Close (t2);
  Assign (t1, '##TEMP##.###');
  {$I-} Reset (t1); {$I+}
  If IOResult <> 0 then Begin
    Writeln ('error: Internal error');
    Halt;
  End;
  Assign (t2, Paramstr (2));
  {$I-} Rewrite (t2); {$I+}
  If IOResult <> 0 then Begin
    Writeln ('error: Cannot create file');
    Halt;
  End;
  Writeln (t2, 'Ambient light color: Red=0.3 Green=0.3 Blue=0.3');
  Writeln (t2);
  Writeln (t2, 'Named object: "Converted_using_CONVASC_by_BoRZoM"');
  Writeln (t2, 'Tri-mesh, Vertices: ', _st(NumVert),'     Faces: ',
                                       _st(NumFace));
  Writeln (t2, 'Vertex list:');
  While not eof (t1) do Begin
    Readln (t1, s1);
    If (Pos ('Vertex', s1)>0)and
       (Pos ('X:', s1)>0)and
       (Pos ('Y:', s1)>0)and
       (Pos ('Z:', s1)>0) then writeln (t2, s1);
  End;
  Close (t1);
  Assign (t1, '##TEMP##.###');
  Reset (t1);
  Writeln (t2, 'Face list:');
  While not eof (t1) do Begin
    Readln (t1, s1);
    If (Pos ('Face', s1)>0)and
       (Pos ('A:', s1)>0)and
       (Pos ('B:', s1)>0)and
       (Pos ('C:', s1)>0) then writeln (t2, s1);
    If Pos ('Smoothing', s1)>0 then writeln (t2, s1);
  End;
  Erase (t1);
  Close (t2);
End.