{$G+,A+,F+}
Unit Controls;

{
  ----------+----------+----------+----------
          Controls unit version 0.10
         Designed/Programmed by BoRZoM
       Copyright (c) 1994 Trouble Makers
  ----------+----------+----------+----------

}

Interface

Const
  scEsc       = 001; scOpenSq    = 026; scCloseSq   = 027; scEnter     = 028;
  scF1        = 059; scF2        = 060; scF3        = 061;
  scF4        = 062; scF5        = 063; scF6        = 064;
  scF7        = 065; scF8        = 066; scF9        = 067;
  scF10       = 068; scF11       = 087; scF12       = 088;
  scScrlLock  = 070; scNumLock   = 069; scCapsLock  = 058;
  scTilde     = 041;
  sc1         = 002; sc2         = 003; sc3         = 004;
  sc4         = 005; sc5         = 006; sc6         = 007;
  sc7         = 008; sc8         = 009; sc9         = 010;
  sc0         = 011;
  scMinus     = 012; scEqual     = 013;
  scBackSpace = 014;
  scTab       = 015;

  scQ         = 016; scW         = 017; scE         = 018;
  scR         = 019; scT         = 020; scY         = 021;
  scU         = 022; scI         = 023; scO         = 024;
  scP         = 025; scA         = 030; scS         = 031;
  scD         = 032; scF         = 033; scG         = 034;
  scH         = 035; scJ         = 036; scK         = 037;
  scL         = 038; scZ         = 044; scX         = 045;
  scC         = 046; scV         = 047; scB         = 048;
  scN         = 049; scM         = 050;

  scSemicolon = 039; scQoute     = 040;

  scLShift    = 042; scRShift    = 054; scCtrl      = 029; scAlt       = 056;
  scBackSlash = 043; scComma     = 051; scPeriod    = 052;
  scSlash     = 053; scSpace     = 057;

  scHome      = 071; scUp        = 072; scPgUp      = 073; scLeft      = 075;
  scKey5      = 076; scRight     = 077; scEnd       = 079; scDown      = 080;
  scPgDn      = 081; scGrayMinus = 074; scGrayPlus  = 078; scAsterisk  = 055;
  scIns       = 082; scDel       = 083;

  COM1        = 0;   COM2        = 1;   COM3        = 2;   COM4        = 3;

  MouseXMin : Integer = 0;
  MouseXMax : Integer = 319;
  MouseYMin : Integer = 0;
  MouseYMax : Integer = 199;

  errOK               =  0;
  errAlreadyInstalled = -1;
  errNotInstalled     = -2;
  errDriverNotFound   = -3;

Type
  MousePos = Record
    LeftButton,
    RightButton : Boolean;
    XPos, YPos,
    XInc, YInc  : Integer;
  End;

Var
  Keyboard       : Array [0..127] of Boolean;
  KeyboardByte   : Byte;
  Mouse          : MousePos;
  kbdUserHandler,
  mouUserHandler : Procedure;

(****************************************************************************)

Function  InitKeyboard : Integer;
Function  RestoreKeyboard : Integer;
Function  InitMouse (COMPort : Byte) : Integer;
Function  RestoreMouse : Integer;

(****************************************************************************)

Implementation

uses DOS;

Const
  MousePORT : Array [COM1..COM4] of Word = ($3F8, $2F8, $3E8, $2E8);
  MouseINTR : Array [COM1..COM4] of Byte = ($0C,  $0B,  $0C,  $0D);

Var
  KeyboardISR,
  MouseISR     : Pointer;
  MouseCOM,
  ByteNum      : Byte;
  Buffer       : Array [0..2] of Byte;

Procedure NewKeyboard; Interrupt;
Begin
  ASM
    IN   AL, 61h
    MOV  AH, AL
    OR   AL, 80h
    OUT  61h, AL
    MOV  AL, AH
    OUT  61h, AL
    MOV  AX, 40h
    MOV  ES, AX
    XOR  AX, AX
    MOV  ES:[17h], AL
    MOV  ES:[18h], AL
    MOV  AL, ES:[1Ch]
    MOV  ES:[1Ah], AL
  End;
  Keyboard [Port [$60] mod 128] := (Port [$60] < 128);
  KeyboardByte := Port [$60];
  If @kbdUserHandler <> NIL then kbdUserHandler;
  Asm
    MOV  AL, 20h
    OUT  20h, AL
  End;
End;

Procedure NewMouse; Interrupt;
Var
  dx, dy : Integer;
  Inbyte : Byte;

Begin
  Inbyte := Port [MousePORT [MouseCOM]];
  If (Inbyte and 64) = 64 Then Bytenum := 0;
  Buffer [Bytenum] := Inbyte;
  Inc (Bytenum);
  If Bytenum = 3 then Begin
    dx := (Buffer [0] and 03) shl 6 + Buffer [1];
    dy := (Buffer [0] and 12) shl 4 + Buffer [2];
    If dx >= 128 Then dx := dx - 256;
    If dy >= 128 Then dy := dy - 256;
    Mouse.XInc := dx;
    Mouse.YInc := dy;
    Mouse.XPos := Mouse.XPos + dx;
    Mouse.YPos := Mouse.YPos + dy;
    If Mouse.XPos < MouseXMin then Mouse.XPos := MouseXMin;
    If Mouse.XPos > MouseXMax then Mouse.XPos := MouseXMax;
    If Mouse.YPos < MouseYMin then Mouse.YPos := MouseYMin;
    If Mouse.YPos > MouseYMax then Mouse.YPos := MouseYMax;
    Mouse.LeftButton  := (Buffer [0] And 32) <> 0;
    Mouse.RightButton := (Buffer [0] And 16) <> 0;
    Bytenum := 0;
    If @mouUserHandler <> NIL then mouUserHandler;
  End else Begin
    Mouse.XInc := 0;
    Mouse.YInc := 0;
  End;
  Port [$20] := $20;
End;

Function InitKeyboard;
Begin
  If KeyboardISR <> NIL then Begin
    InitKeyboard := errAlreadyInstalled;
    Exit;
  End;
  GetIntVec ($09, KeyboardISR);
  SetIntVec ($09, @NewKeyboard);
  Fillchar (Keyboard, Sizeof (Keyboard), 0);
  InitKeyboard := errOK;
End;

Function RestoreKeyboard;
Begin
  If KeyboardISR = NIL then Begin
    RestoreKeyboard := errNotInstalled;
    Exit;
  End;
  SetIntVec ($09, KeyboardISR);
  Fillchar (Keyboard, Sizeof (Keyboard), 0);
  KeyboardISR := NIL;
  RestoreKeyboard := errOK;
End;

Function InitMouse;
Var
  Result : WORD;

Begin
  If MouseISR <> NIL then Begin
    InitMouse := errAlreadyInstalled;
    Exit;
  End;
  ASM
    XOR  AX, AX
    XOR  BX, BX
    INT  33h
    MOV  Result, AX
  End;
  If Result = 0 then Begin
    InitMouse := errDriverNotFound;
    Exit;
  End;
  MouseCOM := COMPort;
  GetIntVec (MouseINTR [MouseCOM], MouseISR);
  SetIntVec (MouseINTR [MouseCOM], @NewMouse);
  Fillchar (Mouse, Sizeof (Mouse), 0);
  Mouse.XPos := MouseXMin;
  Mouse.YPos := MouseYMin;
  InitMouse := errOK;
End;

Function RestoreMouse;
Begin
  If MouseISR = NIL then Begin
    RestoreMouse := errNotInstalled;
    Exit;
  End;
  SetIntVec (MouseINTR [MouseCOM], MouseISR);
  Fillchar (Mouse, Sizeof (Mouse), 0);
  MouseISR := NIL;
  MouseCOM := 0;
  RestoreMouse := errOK;
End;

Begin
  KeyboardISR := NIL;
  MouseISR := NIL;
  kbdUserHandler := NIL;
  mouUserHandler := NIL;
End.