{$O+,F+,G+,A+}
Unit MegalibU;

{
  ----------+----------+----------+-----------
           MEGALIB unit version 0.10
         Designed/Programmed by BoRZoM
       Copyright (c) 1994 Trouble Makers
  ----------+----------+----------+-----------

}

Interface

Var
  MLibError : Integer;
  BytesRead : Word;

Const
  errFileNotFound = -1;   { Library not found   }
  errInvalidLib   = -2;   { Invalid library     }
  errInvalidVer   = -3;   { Invalid version     }
  errNotInLib     = -4;   { File not in library }
  errNoError      =  0;   { Successfull         }

(****************************************************************************)

Procedure MInitLib (S : String);
Procedure MCloseLib;
Procedure MAssign (S : String);
Procedure MBlockread (Var Buf; Num : Word);
Procedure MSeek (N : Longint);
Function  MGetFileSize : Longint;

(****************************************************************************)

Implementation

Const
  Header  : Array [1..41] of Char =
            #04 + 'MegaLibrary v0.10 (c) 1994 TMC' + #04 + #26;
  Version = $0010;

Type
  MegalibHeader = Record
    HeaderID : Array [1..41] of Char;
    Version  : Word;
    NumFiles : Word;
  End;

  FilesDataHeader = Record
    FileName : String [12];
    FileSize : Longint;
    FileCrc  : Longint;
    FileOfs  : Longint;
  End;

  ExeHeader = Record   { Not complete EXE Header, but only info we need }
    ID                 : Array [1..2] of Char;
    BytesInLastPage    : Word;
    FileSizeInPages    : Word;
 End;

Var
  F           : File;
  Fil         : FilesDataHeader;
  Hdr         : MegalibHeader;
  B1, B2, B3  : Longint;
  B4          : Longint;
  Post        : Longint;
  Buf         : Pointer;
  EHeader     : ExeHeader;
  IsEXE       : Boolean;
  Eovrpos     : Longint;

Procedure MInitLib;
Begin
  IsEXE := False;
  EOvrPos := 0;
  Assign (F, S);
  {$I-} Reset (F, 1); {$I+}
  If IOResult <> 0 then Begin
    MLibError := errFileNotFound;
    Exit;
  End;
  Blockread (F, Hdr, Sizeof (Hdr));
  If Hdr.HeaderID[1] = 'Z' then If Hdr.HeaderID[2] = 'M' then Begin
    Seek (F, 0);
    IsEXE := True;
    Blockread (F, EHeader, Sizeof (EHeader));
    Eovrpos := (EHeader.FileSizeInPages - 1) * 512 + EHeader.BytesInLastPage;
    Seek (F, EOvrpos);
    Blockread (F, Hdr, Sizeof (Hdr));
  End;
  If Hdr.HeaderID <> Header then Begin
    MLibError := errInvalidLib;
    Exit;
  End;
  If Hdr.Version <> Version then Begin
    MLibError := errInvalidVer;
    Exit;
  End;
  MLibError := 0;
End;

Procedure MCloseLib;
Begin
  Close (F);
  MLibError := 0;
End;

Function Upcasestr (S : String) : String;

Var
  B  : Byte;
  St : String;

Begin
  St := '';
  For B := 1 to Length (S) do St := St + Upcase(S[B]);
  Upcasestr := St;
End;

Procedure MAssign;

Label Ed;

Begin
  Post := 0;
  Seek (F, eOvrPos + Sizeof (MegaLibHeader));
  For B1 := 1 to Hdr.Numfiles do Begin
    Blockread (F, Fil, Sizeof (Fil));
    If Fil.Filename = Upcasestr (S) then Begin
      Post := Fil.Fileofs;
      B4 := Fil.Filesize;
      Goto Ed;
    End;
  End;
    Ed:
    If Post = 0 then Begin
      MLibError := errNotInLib;
      Exit;
    End else Seek (F, Post + eOvrpos);
  MLibError := 0;
End;

Procedure MBlockRead;
Begin
  If Num <> 0 then
    Blockread (F, Buf, Num, BytesRead)
  else Blockread (F, Buf, B4, BytesRead);
  MLibError := 0;
End;

Function  MGetFileSize;
Begin
  MGetFileSize := Fil.Filesize;
End;

Procedure MSeek;
Begin
  Seek (F, Post + N + eOvrpos);
End;


End.