{$G+,A+}
Unit Score;

{
  ----------+----------+----------+----------
            Score unit version 0.10
         Designed/Programmed by BoRZoM
       Copyright (c) 1994 Trouble Makers
  ----------+----------+----------+----------

}

Interface

Const
  MaxPlayers = 10;
  EncVal     : Byte    = 120;
  MinScore   : Longint = 0;
  ScoreFile  : String  = 'SCORES.DAT';

Type
  POnePlayer = ^TOnePlayer;
  TOnePlayer = Record
    Name  : String [20];
    Score,
    Level,
    Data1,
    Data2 : Longint;
  End;
  TenPlayers = Array [1..MaxPlayers] of POnePlayer; { 1-High, 10-low }

var
  f           : File of TOnePlayer;
  x, y, z     : Integer;
  EmptyPlayer : POnePlayer;
  Players,
  Temp        : TenPlayers;

(****************************************************************************)

Procedure NewFile;    { Creates a new score-file filled with DefaultPlayer }
Procedure ReadScores; { Reads current score-file to Players^ variable }
Procedure WriteScore (Player : POnePlayer); { Adds a new player to score }

(****************************************************************************)

Implementation

Procedure Encrypt;
Begin
  For x := 1 to MaxPlayers do
    For y := 1 to Length (Players [x]^.Name) do
      Players [x]^.Name [y] := Chr (Ord (Players [x]^.Name [y]) xor
                                   (EncVal+y));
End;

Procedure NewFile;
Begin
  Assign (F, ScoreFile);
  Rewrite (F);
  For x := 1 to MaxPlayers do Players [x]^ := EmptyPlayer^;
  Encrypt;
  For x := 1 to MaxPlayers do Write (f, Players [x]^);
  Encrypt;
  Close (F);
End;

Procedure ReadScores;
Begin
  Assign (F, ScoreFile);
  {$I-} Reset (F); {$I+}
  IF IOResult <> 0 then begin
    NewFile;
    Assign (F, ScoreFile);
    Reset (F);
  End;
  For x := 1 to MaxPlayers do Read (f, Players [x]^);
  Encrypt;
  MinScore := Players [MaxPlayers]^.Score;
  Close (f);
End;

Procedure WriteScore (Player : POnePlayer);
Begin
  ReadScores;
  If Player^.Score < MinScore then Exit;
  Assign (F, ScoreFile);
  Rewrite (F);
  z := 1;
  While Players [z]^.Score > Player^.Score do Inc (z);
  { x is now position in score for the new player }
  If z > 1 then for x := 1 to z-1 do Temp [x]^ := Players [x]^;
  If z < MaxPlayers then for x := z+1 to MaxPlayers do
    Temp [x]^ := Players [x-1]^;
  Temp [z]^ := Player^;
  Players := Temp;
  Encrypt;
  For x := 1 to MaxPlayers do Write (F, Players [x]^);
  Encrypt;
  Close (F);
End;

Begin
  For x := 1 to MaxPlayers do New (Players [x]);
  For x := 1 to MaxPlayers do New (Temp [x]);
  New (EmptyPlayer);
End.