(* VGA Library ------------------------------------------------------------ *)
(*                                                                          *)
(* MODULE NAME: VESA Module                                                 *)
(* VERSION    : 0.10                                                        *)
(* LAST CHANGE: 02-10-95                                                    *)
(* AUTHOR     : BoRZoM / [TATOO]                                            *)
(* DIRECTIVES : *) {$G+,A+,E+,F+,R-,S-,D-} (*                               *)
(*                                                                          *)
(*                                                                          *)
(*                                                                          *)
(*                                                                          *)
(*                                                                          *)
(*                                                                          *)
(*                                                                          *)
(*                                                                          *)
(*                                                                          *)
(*                                                                          *)
(*                                                                          *)
(*                          *) UNIT VGAVESA; (*                             *)

(****************************************************************************)
(******************************) INTERFACE (*********************************)
(****************************************************************************)

const
  v640x400x256   = $100;
  v640x480x256   = $101;
  v800x600x16    = $102;
  v800x600x256   = $103;
  v1024x768x16   = $104;
  v1024x768x256  = $105;
  v1280x1024x16  = $106;
  v1280x1024x256 = $107;
  v80x60t        = $108;
  v132x25t       = $109;
  v132x43t       = $10A;
  v132x50t       = $10B;
  v132x60t       = $10C;
  v320x200x32K   = $10D;
  v320x200x64K   = $10E;
  v320x200x16M   = $10F;
  v640x480x32K   = $110;
  v640x480x64K   = $111;
  v640x480x16M   = $112;
  v800x600x32K   = $113;
  v800x600x64K   = $114;
  v800x600x16M   = $115;
  v1024x768x32K  = $116;
  v1024x768x64K  = $117;
  v1024x768x16M  = $118;
  v1280x1024x32K = $119;
  v1280x1024x64K = $11A;
  v1280x1024x16M = $11B;

var
  CurrentBank : Byte;

Function  vSetMode (Mode : Word): Boolean;
Function  vGetMode : Word;
Procedure vSwitchBank (Bank : Byte);

(****************************************************************************)
(****************************) IMPLEMENTATION (******************************)
(****************************************************************************)

Function vGetMode : Word; Assembler;
Asm
  mov  ax, 4F03h
  int  10h
  mov  ax, bx
End;

Function vSetMode (Mode : Word): Boolean; Assembler;
Asm
  mov  ax, 4F02h
  mov  bx, Mode
  int  10h
  cmp  ax, 004Fh
  jne  @Error
  mov  al, true
  jmp  @Done
@Error:
  mov  al, false
  jmp  @Done
@Done:
End;

Procedure vSwitchBank (Bank : Byte); Assembler;
Asm
  mov  al, Bank
  cmp  CurrentBank, al
  je   @End
  mov  CurrentBank, al
  mov  ax, 4F05h
  xor  bx, bx
  adc  dx, 0
  mov  dl, bank
  int  10h
@End:
End;

End.